---
product: "AG Grid"
title: "Change Detection"
description: "The grid has built in change detection. When a value in the grid changes, either via the UI or via the grid API, the grid will check all cells to see which ones need updating and update only those cells, so minimal changes are made to the DOM."
framework: javascript
version: "36.2.0"
related:
    - title: "DOM Virtualisation"
      url: "https://www.ag-grid.com/javascript-data-grid/dom-virtualisation/"
    - title: "Value Cache"
      url: "https://www.ag-grid.com/javascript-data-grid/value-cache/"
    - title: "Row Animation"
      url: "https://www.ag-grid.com/javascript-data-grid/row-animation/"
    - title: "Massive Row Count"
      url: "https://www.ag-grid.com/javascript-data-grid/massive-row-count/"
    - title: "Scrolling Performance"
      url: "https://www.ag-grid.com/javascript-data-grid/scrolling-performance/"
llms: "https://www.ag-grid.com/llms.txt"
---

# Change Detection

The grid has built in change detection. When a value in the grid changes, either via the UI or via the grid API, the grid will check all cells to see which ones need updating and update only those cells, so minimal changes are made to the DOM.

Change detection can be broken down into the following two categories:

1. **Value Change Detection:** When a value for any cell changes (e.g. after an edit), the grid goes through every cell in the grid and compares the current value to the previous value. If the values differ, the cell is refreshed. This allows all cells using `valueGetters` to be kept up to date where a change to one cell (that was edited) may impact the value of another cell (that references the first cell).
2. **Aggregation Change Detection:** When a value for any cell changes, the grid will recalculate all [aggregations](https://www.ag-grid.com/javascript-data-grid/aggregation/) that are impacted by the changed value. This means the grid will automatically keep aggregation results (the values in the grouped row) up to date as the data beneath it changes.

> **Note**
>
> If you are using a custom cell renderer see [Cell Components](https://www.ag-grid.com/javascript-data-grid/component-cell-renderer/) for more details on how to update your component following change detection.

## Example: Change Detection and Value Getters

The example below shows the impact of change detection on value getters. The grid is doing all the refresh by itself with no need for the client application explicitly requesting a refresh. Notice the following:

- The 'Total' column uses a value getter to calculate the sum of all values in that row.
- Edit any of the values in columns A to F by double clicking a cell and entering a new value.
- The 'Total' column gets automatically refreshed and flashes.

#### Change Detection and Value Getters

```ts
import {
  CellStyleModule,
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextEditorModule,
  TextFilterModule,
  HighlightChangesModule,
  CellStyleModule,
  ClientSideRowModelModule,
  NumberFilterModule,
  NumberEditorModule,
]);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    { field: "a", type: "valueColumn" },
    { field: "b", type: "valueColumn" },
    { field: "c", type: "valueColumn" },
    { field: "d", type: "valueColumn" },
    { field: "e", type: "valueColumn" },
    { field: "f", type: "valueColumn" },
    {
      headerName: "Total",
      valueGetter: "data.a + data.b + data.c + data.d + data.e + data.f",
      editable: false,
      cellClass: "total-col",
    },
  ],
  defaultColDef: {
    flex: 1,
    enableCellChangeFlash: true,
  },
  columnTypes: {
    valueColumn: {
      minWidth: 90,
      editable: true,
      filter: "agNumberColumnFilter",
    },
  },
  rowData: getRowData(),
  groupDefaultExpanded: 1,
  suppressAggFuncInHeader: true,
  allowShowChangeAfterFilter: true,
};

function getRowData() {
  const rowData = [];
  for (let i = 1; i <= 20; i++) {
    rowData.push({
      group: i < 5 ? "A" : "B",
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
      e: (i * 619) % 100,
      f: (i * 571) % 100,
    });
  }
  return rowData;
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
```

[Live example: Change Detection and Value Getters](https://www.ag-grid.com/examples/change-detection/change-detection-value-getters/typescript/)

## 1. Value Change Detection

The grid keeps a local copy of all values rendered in each cell. When a refresh of the cell is requested, the cell will only be refreshed if the value has changed.

> **Note**
>
> You might ask, is checking every cell against its value a performance problem? The answer is no. What AG Grid does is similar to the change detection algorithms in frameworks. Doing this many checks in JavaScript is not a problem. Slowness comes when the DOM is updated many times. AG Grid minimises the DOM updates by only updating the DOM where changes are detected.

### Comparing Values

This section explains how the grid compares values. This is of interest if you want to compare values in a different way.

By default the grid will compare values by using triple equals, eg `"oldValue === newValue"`. This will work most of the time for you, especially if your values are simple types (string, number, boolean) or immutable objects. This will be a problem for mutable objects as object references will be used for comparison which won't detect internal changes in the object. If using mutable objects (data has changed but it's the same object reference), then you will need to override how the value's are compared.

If your row data attributes are simple types (string, boolean, number) or immutable objects you don't need to implement your own comparison method.

If you do need to provide custom comparison of objects, use the `colDef.equals(val1,val2)` method. For example, the following code snippet provides custom comparison to a 'Name' column where the name is stored in a complex object.

```js
const gridOptions = {
    columnDefs: [
        {
            field: 'person',
            // method returns true if first and last names are equal
            equals: (person1, person2) => {
                const firstNameEqual = person1.firstName === person2.firstName;
                const lastNameEqual = person2.lastName === person2.lastName;
                return firstNameEqual && lastNameEqual;
            }
        }
    ],

    // other grid options ...
}
```

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `equals` | `EqualsFunc` |  |  |  |

### Triggering Value Change Detection

The following operations will **automatically** trigger change detection on all visible cells:

1. Editing any value via the grid UI (e.g. double clicking a cell and entering a new value).
2. Using the `rowNode.setDataValue(col,value)` Row Node method.
3. Using the `api.applyTransaction(transaction)` API method.
4. Group value edited if `refreshAfterGroupEdit` grid option is set to `true`, (see [Grouping Edit](https://www.ag-grid.com/javascript-data-grid/grouping-edit/)).

If you do not want change detection to be automatically done, then set the grid property `suppressChangeDetection=true`. This will stop the change detection process firing when the above events happen. Ideally you should not want to turn off change detection, however the option is there if you choose to turn it off. One thing that may entice you to turn it off is if you have some custom Value Getters or Cell Class Rules that are doing some time intensive calculations, you may want limit the number of times they are called and have more control over when refreshing is done.

To **manually** run Value Change Detection to refresh all visible cells call [api.refreshCells()](https://www.ag-grid.com/javascript-data-grid/view-refresh/).

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `refreshCells` | `Function` |  |  |  |

## 2. Aggregation Change Detection

Aggregation change detection means rerunning [aggregations](https://www.ag-grid.com/javascript-data-grid/aggregation/) when a value changes. So for example, if you are grouping by a column and summing by a value, and one of those values change, then the summed value should also change.

> **Note**
>
> If you want edited rows to jump to their new groups automatically, enable [Grouping Edit](https://www.ag-grid.com/javascript-data-grid/grouping-edit/) by setting the grid property `refreshAfterGroupEdit=true`. This property triggers the necessary regroup, sort and filter refresh after the edit and is our preferred approach when inline editing grouped columns.

### Flashing Cells During Filter Updates

By default, the grid does not flash cells when filtering is applied, even if the value in the aggregated cell has changed. To change this behaviour, set the grid property `allowShowChangeAfterFilter=true`.

This only affects cell flashing (`enableCellChangeFlash`). The [Value Getters example](https://www.ag-grid.com/javascript-data-grid/change-detection/#example-change-detection-and-value-getters) above sets `allowShowChangeAfterFilter=true`, so that flashing remains visible while filtering. The other examples on this page use [animation cell renderers](https://www.ag-grid.com/javascript-data-grid/change-cell-renderers/) instead of flashing, so the property has no effect on them.

### Example: Re-Aggregation of Groups

The example below shows change detection impacting the result of groups. The grid is doing all the refresh by itself with no need for the client application explicitly requesting a refresh. Notice the following:

- Column 'Group' is marked as a [Row Group](https://www.ag-grid.com/javascript-data-grid/grouping/) and columns A to D are marked as [Aggregation](https://www.ag-grid.com/javascript-data-grid/aggregation/) columns so that their values are summed into the group level.
- Column 'Total' has a valueGetter which gives a sum of all columns A to D.
- Columns A to D are editable. If you edit a cells value, then the aggregate value at the group level is also updated to reflect the change. This is because the grid is recalculating the aggregations as a result of the change.
- All cells are configured to use one of the grids [animation cell renderer](https://www.ag-grid.com/javascript-data-grid/change-cell-renderers/) instead of flashing cells.

#### Change Detection with Groups

```ts
import {
  CellStyleModule,
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextEditorModule,
  TextFilterModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
  HighlightChangesModule,
  NumberFilterModule,
  NumberEditorModule,
]);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    { field: "group", rowGroup: true, editable: true },
    { field: "a", type: "valueColumn" },
    { field: "b", type: "valueColumn" },
    { field: "c", type: "valueColumn" },
    { field: "d", type: "valueColumn" },
    {
      headerName: "Total",
      type: "totalColumn",
      valueGetter:
        'getValue("a") + getValue("b") + getValue("c") + getValue("d")',
    },
  ],
  defaultColDef: {
    flex: 1,
  },
  autoGroupColumnDef: {
    minWidth: 100,
  },
  columnTypes: {
    valueColumn: {
      minWidth: 90,
      editable: true,
      aggFunc: "sum",
      cellClass: "number-cell",
      cellRenderer: "agAnimateShowChangeCellRenderer",
      filter: "agNumberColumnFilter",
    },
    totalColumn: {
      cellRenderer: "agAnimateShowChangeCellRenderer",
      cellClass: "number-cell",
    },
  },
  rowData: getRowData(),
  groupDefaultExpanded: 1,
  suppressAggFuncInHeader: true,
};

function getRowData() {
  const rowData = [];
  for (let i = 1; i <= 16; i++) {
    rowData.push({
      group: i < 8 ? "A" : "B",
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
    });
  }
  return rowData;
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
```

[Live example: Change Detection with Groups](https://www.ag-grid.com/examples/change-detection/change-detection-groups/typescript/)

Notice above that the group column is also editable (eg you can change one of the rows from group 'A' to group 'G'), however the row does **not** move into the correct group after this change is made. This is discussed below in the section [Change Detection and Sorting, Filtering, Grouping](https://www.ag-grid.com/javascript-data-grid/change-detection/#change-detection-and-sorting-filtering-grouping).

### Refreshing Groups After Inline Edits

By default the grid keeps the edited row in place until you manually refresh the client-side row model. This prevents jarring row movement while the user is typing, but it can look incorrect if group edits are infrequent and you expect the row to relocate immediately.

`refreshAfterGroupEdit` flips that behaviour. When set to `true`, the grid automatically reruns grouping, sorting and filtering after the edit is committed, so the row will move according to its new value.

```ts
const gridOptions = {
    refreshAfterGroupEdit: true,
    // other grid options
};
```

See [Grouping Edit](https://www.ag-grid.com/javascript-data-grid/grouping-edit/) for more details.

### Triggering Aggregation Change Detection

The following operations will **automatically** trigger aggregation change detection:

1. Editing any value via the grid UI (e.g. double clicking a cell and entering a new value).
2. Using the `rowNode.setDataValue(col,value)` Row Node method.
3. Using the `api.applyTransaction(transaction)` API method.

To **manually** run aggregation change detection to re-compute the aggregated values, then call [api.refreshClientSideRowModel('aggregate')](https://www.ag-grid.com/javascript-data-grid/grid-api/#reference-data-refreshClientSideRowModel).

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `refreshClientSideRowModel` | `Function` |  |  |  |

## Change Detection and Sorting, Filtering, Grouping

When a value changes, the grid's automatic change detection will update:

- Aggregated values.
- Values displayed in cells.

The grid will **not**:

- Sort
- Filter
- Group

The reason why sorting, filtering and grouping is not done automatically is that it would be considered bad user experience in most use cases to change the displayed rows while editing. For example, if a user edits a cell, then the row should not jump location (due to sorting and grouping) or even worse, disappear altogether (if the filter removes the row due to the new value failing the filter).

For this reason, if you want to update the sorting, filtering or group grouping after an update, you should listen for the event `cellValueChanged` and call [api.applyTransaction(transaction)](https://www.ag-grid.com/javascript-data-grid/data-update-transactions/#transaction-update-api) with the rows that were updated.

### Example: Change Detection and Filter / Sort / Group

The following example is the same as the example above [Change Detection and Groups](https://www.ag-grid.com/javascript-data-grid/change-detection/#example-change-detection-groups) except it gets the grid to do a transaction update so that the grouping, sorting and filtering are recomputed. From the example, the following can be noted:

- As before, updating any value will update the total column and aggregated group columns.
- Updating a group cell will move the row to the new group. If the group does not exist, it will be created.
- If you order by a column (eg order by 'A') and then change the data so that the order is incorrect, the grid will fix itself so that the ordering is maintained. In other words, the updated row will move to the new sorted position.
- If you set a filter (eg filter 'A' to be 'less than 50') and then change the data so that a row no longer passes the filter, the grid will fix itself so that the filtering is maintained. In other words, the updated row will be removed if it no longer passes the filter.

#### Change Detection with Filter / Sort / Group

```ts
import {
  CellStyleModule,
  CellValueChangedEvent,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, SetFilterModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelApiModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
  SetFilterModule,
  HighlightChangesModule,
  NumberFilterModule,
  NumberEditorModule,
  TextEditorModule,
]);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    // do NOT hide this column, it's needed for editing
    { field: "group", rowGroup: true, editable: true },
    { field: "a", type: "valueColumn" },
    { field: "b", type: "valueColumn" },
    { field: "c", type: "valueColumn" },
    { field: "d", type: "valueColumn" },
    {
      colId: "total",
      headerName: "Total",
      type: "totalColumn",
      valueGetter:
        'getValue("a") + getValue("b") + getValue("c") + getValue("d")',
    },
  ],
  defaultColDef: {
    flex: 1,
    filter: true,
  },
  autoGroupColumnDef: {
    minWidth: 100,
  },
  columnTypes: {
    valueColumn: {
      minWidth: 90,
      editable: true,
      aggFunc: "sum",
      cellClass: "number-cell",
      cellRenderer: "agAnimateShowChangeCellRenderer",
      filter: "agNumberColumnFilter",
    },
    totalColumn: {
      cellRenderer: "agAnimateShowChangeCellRenderer",
      cellClass: "number-cell",
    },
  },
  rowData: getRowData(),
  groupDefaultExpanded: 1,
  suppressAggFuncInHeader: true,
  onCellValueChanged: onCellValueChanged,
};

function onCellValueChanged(params: CellValueChangedEvent) {
  const data = params.data;
  if (data) {
    params.api.applyTransaction({ update: [data] });
  }
}

function getRowData() {
  const rowData = [];
  for (let i = 1; i <= 10; i++) {
    rowData.push({
      group: i < 5 ? "A" : "B",
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
    });
  }
  return rowData;
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
```

[Live example: Change Detection with Filter / Sort / Group](https://www.ag-grid.com/examples/change-detection/change-detection-filter-sort-group/typescript/)

## Aggregation Path Selection

When data in the grid updates and aggregations are active, the grid will not recompute all aggregations again from scratch. Instead it will be selective as to what aggregations need to be re-computed.

## Tree Path Selection

When a value changes, the grid will recompute the immediate group the row is in, and then any parent group, all the way to the root. This is known as 'tree path selection' - only the part of the tree that need to be recalculated are recalculated.

If you are updating many rows at the same time using an [Update Transaction](https://www.ag-grid.com/javascript-data-grid/data-update-transactions/), the grid will do all updates first, then recompute all aggregations against the combined impacted paths only.

## Column Path Selection

By default, the grid will recalculate aggregations on all columns for the updated tree path, even if only one of the columns values were changed. This is because the grid assumes any column has the potential to impact any other column, should the column be referenced in a valueGetter.

If you are sure that a value change impacts that one column only, then you can set the grid property `aggregateOnlyChangedColumns=true`. This will re-aggregate only the changed column and not all columns after a single cell is updated.

## Example: Tree Path & Column Path Selection

Consider the example below. When you edit a cell value under the groups "Bottom" -> "Group B2" and column "Column C". The grid will only recompute column C aggregations for "Group B2" and "Bottom". It will not recompute any aggregates for any other groups or for any other columns.

The tree path selection (ie not updating anything in the group "Top") is always active in the grid and the column selection (only updating column "Column C") is active because of the grid property `aggregateOnlyChangedColumns=true`.

The path selections ensure only the minimal amount of recalculations are done.

To demonstrate this, the example installs it's own aggregation function for summing. This is identical to the normal summing provided by the grid while also printing out to the console when it gets called. This allows the example to show when the aggregations are done and on what.

So with the example below, open up the console and notice the following:

- When the grid initialises, the aggregation gets complete 48 times (4 columns * 12 groups). That's all paths in the group tree and all columns.
- When one value changes (either via UI or via the first button 'Update One Value') then the grid recomputes the values for the impacted path only, and for the changed column only.
- When some values change via a transactions using any of the other buttons, then all columns are recomputed but only on the changed path.

#### Change Detection with Delta Aggregation

```ts
import {
  CellStyleModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  GetRowIdParams,
  GridApi,
  GridOptions,
  HighlightChangesModule,
  IRowNode,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  ValueParserParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, SetFilterModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelApiModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
  SetFilterModule,
  HighlightChangesModule,
  NumberFilterModule,
  NumberEditorModule,
  TextEditorModule,
]);

let rowIdCounter = 0;
let callCount = 0;

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    { field: "topGroup", rowGroup: true, hide: true },
    { field: "group", rowGroup: true, hide: true },
    { headerName: "ID", field: "id", cellClass: "number-cell", maxWidth: 70 },
    { field: "a", type: "valueColumn" },
    { field: "b", type: "valueColumn" },
    { field: "c", type: "valueColumn" },
    { field: "d", type: "valueColumn" },
    {
      headerName: "Total",
      type: "totalColumn",
      minWidth: 120,
      valueGetter:
        'getValue("a") + getValue("b") + getValue("c") + getValue("d")',
    },
  ],
  defaultColDef: {
    flex: 1,
  },
  autoGroupColumnDef: {
    minWidth: 180,
  },
  columnTypes: {
    valueColumn: {
      minWidth: 90,
      editable: true,
      aggFunc: "sum",
      cellClass: "number-cell",
      cellRenderer: "agAnimateShowChangeCellRenderer",
      filter: "agNumberColumnFilter",
    },
    totalColumn: {
      cellRenderer: "agAnimateShowChangeCellRenderer",
      cellClass: "number-cell",
    },
  },
  // set this to true, so only the column in question gets updated
  aggregateOnlyChangedColumns: true,
  aggFuncs: {
    sum: (params) => {
      const values = params && params.values ? params.values : [];
      let result = 0;
      if (values) {
        values.forEach((value) => {
          if (typeof value === "number") {
            result += value;
          }
        });
      }
      callCount++;
      console.log(
        callCount + " aggregation: sum([" + values.join(",") + "]) = " + result,
      );
      return result;
    },
  },
  groupDefaultExpanded: 1,
  suppressAggFuncInHeader: true,
  getRowId: (params: GetRowIdParams) => String(params.data.id),
  onGridReady: (params) => {
    params.api.setGridOption("rowData", createRowData());
  },
};

function createRowData() {
  const result = [];
  for (let i = 1; i <= 2; i++) {
    for (let j = 1; j <= 5; j++) {
      for (let k = 1; k <= 3; k++) {
        const rowDataItem = createRowItem(i, j, k);
        result.push(rowDataItem);
      }
    }
  }
  return result;
}

function createRowItem(i: number, j: number, k: number) {
  const rowDataItem = {
    id: rowIdCounter++,
    a: (j * k * 863) % 100,
    b: (j * k * 811) % 100,
    c: (j * k * 743) % 100,
    d: (j * k * 677) % 100,
    topGroup: "Bottom",
    group: "Group B" + j,
  };
  if (i === 1) {
    rowDataItem.topGroup = "Top";
    rowDataItem.group = "Group A" + j;
  }
  return rowDataItem;
}

function updateOneRecord() {
  const rowNodeToUpdate = pickExistingRowNodeAtRandom(gridApi!);

  if (!rowNodeToUpdate) return;

  const randomValue = createRandomNumber();
  const randomColumnId = pickRandomColumn();

  console.log(
    "updating " + randomColumnId + " to " + randomValue + " on ",
    rowNodeToUpdate.data,
  );
  rowNodeToUpdate.setDataValue(randomColumnId, randomValue);
}

function pickRandomColumn() {
  const letters = ["a", "b", "c", "d"];
  const randomIndex = Math.floor(window.agRandom() * letters.length);
  return letters[randomIndex];
}

function createRandomNumber() {
  return Math.floor(window.agRandom() * 100);
}

function pickExistingRowItemAtRandom(api: GridApi) {
  const rowNode = pickExistingRowNodeAtRandom(api);
  return rowNode ? rowNode.data : null;
}

function pickExistingRowNodeAtRandom(api: GridApi): IRowNode | undefined {
  const allItems: IRowNode[] = [];
  api.forEachLeafNode(function (rowNode) {
    allItems.push(rowNode);
  });

  if (allItems.length === 0) {
    return undefined;
  }
  const result = allItems[Math.floor(window.agRandom() * allItems.length)];

  return result;
}

function updateUsingTransaction() {
  const itemToUpdate = pickExistingRowItemAtRandom(gridApi!);
  if (!itemToUpdate) {
    return;
  }

  console.log("updating - before", itemToUpdate);

  itemToUpdate[pickRandomColumn()] = createRandomNumber();
  itemToUpdate[pickRandomColumn()] = createRandomNumber();

  const transaction = {
    update: [itemToUpdate],
  };

  console.log("updating - after", itemToUpdate);

  gridApi!.applyTransaction(transaction);
}

function removeUsingTransaction() {
  const itemToRemove = pickExistingRowItemAtRandom(gridApi!);
  if (!itemToRemove) {
    return;
  }

  const transaction = {
    remove: [itemToRemove],
  };

  console.log("removing", itemToRemove);

  gridApi!.applyTransaction(transaction);
}

function addUsingTransaction() {
  const i = Math.floor(window.agRandom() * 2);
  const j = Math.floor(window.agRandom() * 5);
  const k = Math.floor(window.agRandom() * 3);
  const newItem = createRowItem(i, j, k);

  const transaction = {
    add: [newItem],
  };

  console.log("adding", newItem);

  gridApi!.applyTransaction(transaction);
}

function changeGroupUsingTransaction() {
  const itemToUpdate = pickExistingRowItemAtRandom(gridApi!);
  if (!itemToUpdate) {
    return;
  }

  itemToUpdate.topGroup = itemToUpdate.topGroup === "Top" ? "Bottom" : "Top";

  const transaction = {
    update: [itemToUpdate],
  };

  console.log("updating", itemToUpdate);

  gridApi!.applyTransaction(transaction);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).updateOneRecord = updateOneRecord;
  (<any>window).updateUsingTransaction = updateUsingTransaction;
  (<any>window).removeUsingTransaction = removeUsingTransaction;
  (<any>window).addUsingTransaction = addUsingTransaction;
  (<any>window).changeGroupUsingTransaction = changeGroupUsingTransaction;
}
```

[Live example: Change Detection with Delta Aggregation](https://www.ag-grid.com/examples/change-detection/change-detection-delta-aggregation/typescript/)

## Change Detection and Pivot

Everything above stands for when you are doing [pivoting](https://www.ag-grid.com/javascript-data-grid/pivoting/). There are no new concepts to introduce, so let's just get stuck into an example.

When you click any of the buttons below, remember you are not changing the displayed cells values, as when you pivot, each cell is an aggregation of underlying data and the underlying data is no longer displayed in the grid (doing a pivot removes leaf nodes).

From the example, you can observe:

- Uncheck '**Group & Pivot**' to see what the data looks like when it is flat. You can see it's a list of student records showing student scores and age. For seeing the impact of value changes on pivots, keep this checked while selecting the other buttons.
- Button '**Set One Value**' updates one value using `rowNode.setDataValue(col,value)`. The grid aggregates the new value for display.
- Button '**Update Points**' updates one record using `api.applyTransaction(transaction)`. The grid aggregates the new value for display.
- Button '**Add Year 5**' adds one record for 'Year 5' using `api.applyTransaction(transaction)`. The grid does a delta change and adds one more row to represent this group while not touching the DOM with the remaining rows.
- Button '**Add Physics Row**' adds one record with subject 'Physics' using `api.applyTransaction(transaction)`. This impacts the columns in the grid as we are pivoting on 'course', so a new column is added for 'Physics'. Again this is all done without touching the remaining columns or rows in the grid.
- Button '**Remove All Physics**' removes all 'Physics' records `api.applyTransaction(transaction)`. As before, this impacts the columns, all 'Physics' columns are removed.
- Button '**Move Course**' updates a row's course using `api.applyTransaction(transaction)`. This results in the aggregations changing in two locations, once where the course was removed, and another where the course was added.

#### Change Detection Pivot

```ts
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColumnApiModule,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  IRowNode,
  ModuleRegistry,
  ValueGetterParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { PivotModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnApiModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  PivotModule,
  HighlightChangesModule,
]);

interface Student {
  student: number;
  yearGroup: string;
  age: number;
  course: string;
  points: number;
}

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    { headerName: "Student ID", field: "student" },
    { headerName: "Year Group", field: "yearGroup", rowGroup: true },
    { headerName: "Age", field: "age" },
    { headerName: "Course", field: "course", pivot: true },
    {
      headerName: "Age Range",
      valueGetter: ageRangeValueGetter,
      pivot: true,
    },
    { headerName: "Points", field: "points", aggFunc: "sum" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 150,
    cellRenderer: "agAnimateShowChangeCellRenderer",
  },
  rowData: getRowData(),
  pivotMode: true,
  groupDefaultExpanded: 1,
  getRowId: (params: GetRowIdParams) => String(params.data.student),
  onGridReady: (params: GridReadyEvent) => {
    (document.getElementById("pivot-mode") as HTMLInputElement).checked = true;
  },
};

function ageRangeValueGetter(params: ValueGetterParams) {
  const age = params.getValue("age");
  if (age === undefined) {
    return null;
  }
  if (age < 20) {
    return "< 20";
  } else if (age > 30) {
    return "> 30";
  } else {
    return "20 to 30";
  }
}

// pretty basic, but deterministic (so same numbers each time we run), random number generator
var seed: number;
function random() {
  seed = ((seed || 1) * 16807) % 2147483647;
  return seed;
}

function getRowData() {
  const rowData = [];
  for (let i = 1; i <= 100; i++) {
    const row = createRow();
    rowData.push(row);
  }
  return rowData;
}

var studentId: number;
function createRow() {
  studentId = studentId ? studentId : 10023;
  const randomNumber = random();
  return {
    student: studentId++,
    points: (randomNumber % 60) + 40,
    course: ["Science", "History"][randomNumber % 3 === 0 ? 0 : 1],
    yearGroup: "Year " + ((randomNumber % 4) + 1), // 'Year 1' to 'Year 4'
    age: (randomNumber % 25) + 15, // 15 to 40
  };
}

function pivotMode() {
  const pivotModeOn = (
    document.getElementById("pivot-mode") as HTMLInputElement
  ).checked;

  gridApi!.setGridOption("pivotMode", pivotModeOn);

  gridApi!.applyColumnState({
    state: [
      { colId: "yearGroup", rowGroup: pivotModeOn },
      { colId: "course", pivot: pivotModeOn, pivotIndex: 1 },
      { colId: "ageRange", pivot: pivotModeOn, pivotIndex: 0 },
    ],
  });
}

function updateOneRecord() {
  const rowNodeToUpdate = pickExistingRowNodeAtRandom(gridApi!);
  if (!rowNodeToUpdate) return;

  const randomValue = createNewRandomScore(rowNodeToUpdate.data);
  console.log(
    "updating points to " + randomValue + " on ",
    rowNodeToUpdate.data,
  );
  rowNodeToUpdate.setDataValue("points", randomValue);
}

function createNewRandomScore(data: Student) {
  let randomValue = createRandomNumber();
  // make sure random number is not actually the same number again
  while (randomValue === data.points) {
    randomValue = createRandomNumber();
  }
  return randomValue;
}

function createRandomNumber() {
  return Math.floor(window.agRandom() * 100);
}

function pickExistingRowNodeAtRandom(api: GridApi) {
  const allItems: IRowNode[] = [];
  api.forEachLeafNode(function (rowNode) {
    allItems.push(rowNode);
  });

  if (allItems.length === 0) {
    return;
  }
  const result = allItems[Math.floor(window.agRandom() * allItems.length)];

  return result;
}

function pickExistingRowItemAtRandom(api: GridApi): Student | null {
  const rowNode = pickExistingRowNodeAtRandom(api);
  return rowNode ? rowNode.data : null;
}

function updateUsingTransaction() {
  const itemToUpdate = pickExistingRowItemAtRandom(gridApi!);
  if (!itemToUpdate) {
    return;
  }

  console.log("updating - before", itemToUpdate);
  itemToUpdate.points = createNewRandomScore(itemToUpdate);
  const transaction = {
    update: [itemToUpdate],
  };
  console.log("updating - after", itemToUpdate);
  gridApi!.applyTransaction(transaction);
}

function addNewGroupUsingTransaction() {
  const item1 = createRow();
  const item2 = createRow();
  item1.yearGroup = "Year 5";
  item2.yearGroup = "Year 5";
  const transaction = {
    add: [item1, item2],
  };
  console.log("add - ", item1);
  console.log("add - ", item2);
  gridApi!.applyTransaction(transaction);
}

function addNewCourse() {
  const item1 = createRow();
  item1.course = "Physics";
  const transaction = {
    add: [item1],
  };
  console.log("add - ", item1);
  gridApi!.applyTransaction(transaction);
}

function removePhysics() {
  const allPhysics: any = [];
  gridApi!.forEachLeafNode(function (rowNode) {
    if (rowNode.data.course === "Physics") {
      allPhysics.push(rowNode.data);
    }
  });
  const transaction = {
    remove: allPhysics,
  };
  console.log("removing " + allPhysics.length + " physics items.");
  gridApi!.applyTransaction(transaction);
}

function moveCourse() {
  const item = pickExistingRowItemAtRandom(gridApi!);
  if (!item) {
    return;
  }
  item.course = item.course === "History" ? "Science" : "History";
  const transaction = {
    update: [item],
  };
  console.log("moving ", item);
  gridApi!.applyTransaction(transaction);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).pivotMode = pivotMode;
  (<any>window).updateOneRecord = updateOneRecord;
  (<any>window).updateUsingTransaction = updateUsingTransaction;
  (<any>window).addNewGroupUsingTransaction = addNewGroupUsingTransaction;
  (<any>window).addNewCourse = addNewCourse;
  (<any>window).removePhysics = removePhysics;
  (<any>window).moveCourse = moveCourse;
}
```

[Live example: Change Detection Pivot](https://www.ag-grid.com/examples/change-detection/change-detection-pivot/typescript/)


---
title: "Change Detection"
framework: angular
version: "36.1.0"
---

# Change Detection

The grid has built in change detection. When a value in the grid changes, either via the UI or via the grid API, the grid will check all cells to see which ones need updating and update only those cells, so minimal changes are made to the DOM.

Change detection can be broken down into the following two categories:

1. **Value Change Detection:** When a value for any cell changes (e.g. after an edit), the grid goes through every cell in the grid and compares the current value to the previous value. If the values differ, the cell is refreshed. This allows all cells using `valueGetters` to be kept up to date where a change to one cell (that was edited) may impact the value of another cell (that references the first cell).
2. **Aggregation Change Detection:** When a value for any cell changes, the grid will recalculate all [aggregations](https://www.ag-grid.com/angular-data-grid/aggregation/) that are impacted by the changed value. This means the grid will automatically keep aggregation results (the values in the grouped row) up to date as the data beneath it changes.

> **Note**
>
> If you are using a custom cell renderer see [Cell Components](https://www.ag-grid.com/angular-data-grid/component-cell-renderer/) for more details on how to update your component following change detection.

## Example: Change Detection and Value Getters

The example below shows the impact of change detection on value getters. The grid is doing all the refresh by itself with no need for the client application explicitly requesting a refresh. Notice the following:

- The 'Total' column uses a value getter to calculate the sum of all values in that row.
- Edit any of the values in columns A to F by double clicking a cell and entering a new value.
- The 'Total' column gets automatically refreshed and flashes.

#### Change Detection and Value Getters

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextEditorModule,
  TextFilterModule,
  HighlightChangesModule,
  CellStyleModule,
  ClientSideRowModelModule,
  NumberFilterModule,
  NumberEditorModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [columnTypes]="columnTypes"
    [rowData]="rowData"
    [groupDefaultExpanded]="groupDefaultExpanded"
    [suppressAggFuncInHeader]="true"
    [allowShowChangeAfterFilter]="true"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "a", type: "valueColumn" },
    { field: "b", type: "valueColumn" },
    { field: "c", type: "valueColumn" },
    { field: "d", type: "valueColumn" },
    { field: "e", type: "valueColumn" },
    { field: "f", type: "valueColumn" },
    {
      headerName: "Total",
      valueGetter: "data.a + data.b + data.c + data.d + data.e + data.f",
      editable: false,
      cellClass: "total-col",
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    enableCellChangeFlash: true,
  };
  columnTypes: ColTypeDefs = {
    valueColumn: {
      minWidth: 90,
      editable: true,
      filter: "agNumberColumnFilter",
    },
  };
  rowData: any[] | null = getRowData();
  groupDefaultExpanded = 1;
}

function getRowData() {
  const rowData = [];
  for (let i = 1; i <= 20; i++) {
    rowData.push({
      group: i < 5 ? "A" : "B",
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
      e: (i * 619) % 100,
      f: (i * 571) % 100,
    });
  }
  return rowData;
}
```

[Live example: Change Detection and Value Getters](https://www.ag-grid.com/examples/change-detection/change-detection-value-getters/angular)

## 1. Value Change Detection

The grid keeps a local copy of all values rendered in each cell. When a refresh of the cell is requested, the cell will only be refreshed if the value has changed.

> **Note**
>
> You might ask, is checking every cell against its value a performance problem? The answer is no. What AG Grid does is similar to the change detection algorithms in frameworks. Doing this many checks in JavaScript is not a problem. Slowness comes when the DOM is updated many times. AG Grid minimises the DOM updates by only updating the DOM where changes are detected.

### Comparing Values

This section explains how the grid compares values. This is of interest if you want to compare values in a different way.

By default the grid will compare values by using triple equals, eg `"oldValue === newValue"`. This will work most of the time for you, especially if your values are simple types (string, number, boolean) or immutable objects. This will be a problem for mutable objects as object references will be used for comparison which won't detect internal changes in the object. If using mutable objects (data has changed but it's the same object reference), then you will need to override how the value's are compared.

If your row data attributes are simple types (string, boolean, number) or immutable objects you don't need to implement your own comparison method.

If you do need to provide custom comparison of objects, use the `colDef.equals(val1,val2)` method. For example, the following code snippet provides custom comparison to a 'Name' column where the name is stored in a complex object.

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: 'person',
        // method returns true if first and last names are equal
        equals: (person1, person2) => {
            const firstNameEqual = person1.firstName === person2.firstName;
            const lastNameEqual = person2.lastName === person2.lastName;
            return firstNameEqual && lastNameEqual;
        }
    }
];
```

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `equals` | `EqualsFunc` |  |  | Custom comparator for values, used by renderer to know if values have changed. Cells whose values have not changed don't get refreshed. By default the grid uses `===` which should work for most use cases. |

### Triggering Value Change Detection

The following operations will **automatically** trigger change detection on all visible cells:

1. Editing any value via the grid UI (e.g. double clicking a cell and entering a new value).
2. Using the `rowNode.setDataValue(col,value)` Row Node method.
3. Using the `api.applyTransaction(transaction)` API method.
4. Group value edited if `refreshAfterGroupEdit` grid option is set to `true`, (see [Grouping Edit](https://www.ag-grid.com/angular-data-grid/grouping-edit/)).

If you do not want change detection to be automatically done, then set the grid property `suppressChangeDetection=true`. This will stop the change detection process firing when the above events happen. Ideally you should not want to turn off change detection, however the option is there if you choose to turn it off. One thing that may entice you to turn it off is if you have some custom Value Getters or Cell Class Rules that are doing some time intensive calculations, you may want limit the number of times they are called and have more control over when refreshing is done.

To **manually** run Value Change Detection to refresh all visible cells call [api.refreshCells()](https://www.ag-grid.com/angular-data-grid/view-refresh/).

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `refreshCells` | `Function` |  |  | Performs change detection on all cells, refreshing cells where required. Module: [`RenderApiModule`](https://www.ag-grid.com/angular-data-grid/modules/). |

## 2. Aggregation Change Detection

Aggregation change detection means rerunning [aggregations](https://www.ag-grid.com/angular-data-grid/aggregation/) when a value changes. So for example, if you are grouping by a column and summing by a value, and one of those values change, then the summed value should also change.

> **Note**
>
> If you want edited rows to jump to their new groups automatically, enable [Grouping Edit](https://www.ag-grid.com/angular-data-grid/grouping-edit/) by setting the grid property `refreshAfterGroupEdit=true`. This property triggers the necessary regroup, sort and filter refresh after the edit and is our preferred approach when inline editing grouped columns.

### Flashing Cells During Filter Updates

By default, the grid does not flash cells when filtering is applied, even if the value in the aggregated cell has changed. To change this behaviour, set the grid property `allowShowChangeAfterFilter=true`.

This only affects cell flashing (`enableCellChangeFlash`). The [Value Getters example](#example-change-detection-and-value-getters) above sets `allowShowChangeAfterFilter=true`, so that flashing remains visible while filtering. The other examples on this page use [animation cell renderers](https://www.ag-grid.com/angular-data-grid/change-cell-renderers/) instead of flashing, so the property has no effect on them.

### Example: Re-Aggregation of Groups

The example below shows change detection impacting the result of groups. The grid is doing all the refresh by itself with no need for the client application explicitly requesting a refresh. Notice the following:

- Column 'Group' is marked as a [Row Group](https://www.ag-grid.com/angular-data-grid/grouping/) and columns A to D are marked as [Aggregation](https://www.ag-grid.com/angular-data-grid/aggregation/) columns so that their values are summed into the group level.
- Column 'Total' has a valueGetter which gives a sum of all columns A to D.
- Columns A to D are editable. If you edit a cells value, then the aggregate value at the group level is also updated to reflect the change. This is because the grid is recalculating the aggregations as a result of the change.
- All cells are configured to use one of the grids [animation cell renderer](https://www.ag-grid.com/angular-data-grid/change-cell-renderers/) instead of flashing cells.

#### Change Detection with Groups

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  AutoGroupColumnDef,
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextEditorModule,
  TextFilterModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
  HighlightChangesModule,
  NumberFilterModule,
  NumberEditorModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [columnTypes]="columnTypes"
    [rowData]="rowData"
    [groupDefaultExpanded]="groupDefaultExpanded"
    [suppressAggFuncInHeader]="true"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "group", rowGroup: true, editable: true },
    { field: "a", type: "valueColumn" },
    { field: "b", type: "valueColumn" },
    { field: "c", type: "valueColumn" },
    { field: "d", type: "valueColumn" },
    {
      headerName: "Total",
      type: "totalColumn",
      valueGetter:
        'getValue("a") + getValue("b") + getValue("c") + getValue("d")',
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 100,
  };
  columnTypes: ColTypeDefs = {
    valueColumn: {
      minWidth: 90,
      editable: true,
      aggFunc: "sum",
      cellClass: "number-cell",
      cellRenderer: "agAnimateShowChangeCellRenderer",
      filter: "agNumberColumnFilter",
    },
    totalColumn: {
      cellRenderer: "agAnimateShowChangeCellRenderer",
      cellClass: "number-cell",
    },
  };
  rowData: any[] | null = getRowData();
  groupDefaultExpanded = 1;
}

function getRowData() {
  const rowData = [];
  for (let i = 1; i <= 16; i++) {
    rowData.push({
      group: i < 8 ? "A" : "B",
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
    });
  }
  return rowData;
}
```

[Live example: Change Detection with Groups](https://www.ag-grid.com/examples/change-detection/change-detection-groups/angular)

Notice above that the group column is also editable (eg you can change one of the rows from group 'A' to group 'G'), however the row does **not** move into the correct group after this change is made. This is discussed below in the section [Change Detection and Sorting, Filtering, Grouping](#change-detection-and-sorting-filtering-grouping).

### Refreshing Groups After Inline Edits

By default the grid keeps the edited row in place until you manually refresh the client-side row model. This prevents jarring row movement while the user is typing, but it can look incorrect if group edits are infrequent and you expect the row to relocate immediately.

`refreshAfterGroupEdit` flips that behaviour. When set to `true`, the grid automatically reruns grouping, sorting and filtering after the edit is committed, so the row will move according to its new value.

```ts
const gridOptions = {
    refreshAfterGroupEdit: true,
    // other grid options
};
```

See [Grouping Edit](https://www.ag-grid.com/angular-data-grid/grouping-edit/) for more details.

### Triggering Aggregation Change Detection

The following operations will **automatically** trigger aggregation change detection:

1. Editing any value via the grid UI (e.g. double clicking a cell and entering a new value).
2. Using the `rowNode.setDataValue(col,value)` Row Node method.
3. Using the `api.applyTransaction(transaction)` API method.

To **manually** run aggregation change detection to re-compute the aggregated values, then call [api.refreshClientSideRowModel('aggregate')](https://www.ag-grid.com/angular-data-grid/grid-api/#reference-data-refreshClientSideRowModel).

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `refreshClientSideRowModel` | `Function` |  |  | Refresh the Client-Side Row Model, executing the grouping, filtering and sorting again. Optionally provide the step you wish the refresh to apply from. Defaults to `everything`. Module: [`ClientSideRowModelApiModule`](https://www.ag-grid.com/angular-data-grid/modules/). |

## Change Detection and Sorting, Filtering, Grouping

When a value changes, the grid's automatic change detection will update:

- Aggregated values.
- Values displayed in cells.

The grid will **not**:

- Sort
- Filter
- Group

The reason why sorting, filtering and grouping is not done automatically is that it would be considered bad user experience in most use cases to change the displayed rows while editing. For example, if a user edits a cell, then the row should not jump location (due to sorting and grouping) or even worse, disappear altogether (if the filter removes the row due to the new value failing the filter).

For this reason, if you want to update the sorting, filtering or group grouping after an update, you should listen for the event `cellValueChanged` and call [api.applyTransaction(transaction)](https://www.ag-grid.com/angular-data-grid/data-update-transactions/#transaction-update-api) with the rows that were updated.

### Example: Change Detection and Filter / Sort / Group

The following example is the same as the example above [Change Detection and Groups](#example-change-detection-groups) except it gets the grid to do a transaction update so that the grouping, sorting and filtering are recomputed. From the example, the following can be noted:

- As before, updating any value will update the total column and aggregated group columns.
- Updating a group cell will move the row to the new group. If the group does not exist, it will be created.
- If you order by a column (eg order by 'A') and then change the data so that the order is incorrect, the grid will fix itself so that the ordering is maintained. In other words, the updated row will move to the new sorted position.
- If you set a filter (eg filter 'A' to be 'less than 50') and then change the data so that a row no longer passes the filter, the grid will fix itself so that the filtering is maintained. In other words, the updated row will be removed if it no longer passes the filter.

#### Change Detection with Filter / Sort / Group

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  AutoGroupColumnDef,
  CellStyleModule,
  CellValueChangedEvent,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, SetFilterModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelApiModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
  SetFilterModule,
  HighlightChangesModule,
  NumberFilterModule,
  NumberEditorModule,
  TextEditorModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [columnTypes]="columnTypes"
    [rowData]="rowData"
    [groupDefaultExpanded]="groupDefaultExpanded"
    [suppressAggFuncInHeader]="true"
    (cellValueChanged)="onCellValueChanged($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    // do NOT hide this column, it's needed for editing
    { field: "group", rowGroup: true, editable: true },
    { field: "a", type: "valueColumn" },
    { field: "b", type: "valueColumn" },
    { field: "c", type: "valueColumn" },
    { field: "d", type: "valueColumn" },
    {
      headerName: "Total",
      type: "totalColumn",
      valueGetter:
        'getValue("a") + getValue("b") + getValue("c") + getValue("d")',
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    filter: true,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 100,
  };
  columnTypes: ColTypeDefs = {
    valueColumn: {
      minWidth: 90,
      editable: true,
      aggFunc: "sum",
      cellClass: "number-cell",
      cellRenderer: "agAnimateShowChangeCellRenderer",
      filter: "agNumberColumnFilter",
    },
    totalColumn: {
      cellRenderer: "agAnimateShowChangeCellRenderer",
      cellClass: "number-cell",
    },
  };
  rowData: any[] | null = getRowData();
  groupDefaultExpanded = 1;

  onCellValueChanged(params: CellValueChangedEvent) {
    const data = params.data;
    if (data) {
      params.api.applyTransaction({ update: [data] });
    }
  }
}

function getRowData() {
  const rowData = [];
  for (let i = 1; i <= 10; i++) {
    rowData.push({
      group: i < 5 ? "A" : "B",
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
    });
  }
  return rowData;
}
```

[Live example: Change Detection with Filter / Sort / Group](https://www.ag-grid.com/examples/change-detection/change-detection-filter-sort-group/angular)

## Aggregation Path Selection

When data in the grid updates and aggregations are active, the grid will not recompute all aggregations again from scratch. Instead it will be selective as to what aggregations need to be re-computed.

## Tree Path Selection

When a value changes, the grid will recompute the immediate group the row is in, and then any parent group, all the way to the root. This is known as 'tree path selection' - only the part of the tree that need to be recalculated are recalculated.

If you are updating many rows at the same time using an [Update Transaction](https://www.ag-grid.com/angular-data-grid/data-update-transactions/), the grid will do all updates first, then recompute all aggregations against the combined impacted paths only.

## Column Path Selection

By default, the grid will recalculate aggregations on all columns for the updated tree path, even if only one of the columns values were changed. This is because the grid assumes any column has the potential to impact any other column, should the column be referenced in a valueGetter.

If you are sure that a value change impacts that one column only, then you can set the grid property `aggregateOnlyChangedColumns=true`. This will re-aggregate only the changed column and not all columns after a single cell is updated.

## Example: Tree Path & Column Path Selection

Consider the example below. When you edit a cell value under the groups "Bottom" -> "Group B2" and column "Column C". The grid will only recompute column C aggregations for "Group B2" and "Bottom". It will not recompute any aggregates for any other groups or for any other columns.

The tree path selection (ie not updating anything in the group "Top") is always active in the grid and the column selection (only updating column "Column C") is active because of the grid property `aggregateOnlyChangedColumns=true`.

The path selections ensure only the minimal amount of recalculations are done.

To demonstrate this, the example installs it's own aggregation function for summing. This is identical to the normal summing provided by the grid while also printing out to the console when it gets called. This allows the example to show when the aggregations are done and on what.

So with the example below, open up the console and notice the following:

- When the grid initialises, the aggregation gets complete 48 times (4 columns * 12 groups). That's all paths in the group tree and all columns.
- When one value changes (either via UI or via the first button 'Update One Value') then the grid recomputes the values for the impacted path only, and for the changed column only.
- When some values change via a transactions using any of the other buttons, then all columns are recomputed but only on the changed path.

#### Change Detection with Delta Aggregation

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
  AutoGroupColumnDef,
  CellStyleModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  IAggFuncs,
  IRowNode,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  ValueParserParams,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, SetFilterModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelApiModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
  SetFilterModule,
  HighlightChangesModule,
  NumberFilterModule,
  NumberEditorModule,
  TextEditorModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="parent-container">
    <div class="top-container">
      <button (click)="updateOneRecord()">Update One Value</button>
      <button (click)="updateUsingTransaction()">
        Update Using Transaction
      </button>
      <button (click)="removeUsingTransaction()">
        Remove Using Transaction
      </button>
      <button (click)="addUsingTransaction()">Add Using Transaction</button>
      <button (click)="changeGroupUsingTransaction()">
        Change Group Using Transaction
      </button>
    </div>
    <div class="center-container">
      <ag-grid-angular
        style="width: 100%; height: 100%;"
        [columnDefs]="columnDefs"
        [defaultColDef]="defaultColDef"
        [autoGroupColumnDef]="autoGroupColumnDef"
        [columnTypes]="columnTypes"
        [aggregateOnlyChangedColumns]="true"
        [aggFuncs]="aggFuncs"
        [groupDefaultExpanded]="groupDefaultExpanded"
        [suppressAggFuncInHeader]="true"
        [getRowId]="getRowId"
        [rowData]="rowData"
        (gridReady)="onGridReady($event)"
      />
    </div>
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  columnDefs: ColDef[] = [
    { field: "topGroup", rowGroup: true, hide: true },
    { field: "group", rowGroup: true, hide: true },
    { headerName: "ID", field: "id", cellClass: "number-cell", maxWidth: 70 },
    { field: "a", type: "valueColumn" },
    { field: "b", type: "valueColumn" },
    { field: "c", type: "valueColumn" },
    { field: "d", type: "valueColumn" },
    {
      headerName: "Total",
      type: "totalColumn",
      minWidth: 120,
      valueGetter:
        'getValue("a") + getValue("b") + getValue("c") + getValue("d")',
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 180,
  };
  columnTypes: ColTypeDefs = {
    valueColumn: {
      minWidth: 90,
      editable: true,
      aggFunc: "sum",
      cellClass: "number-cell",
      cellRenderer: "agAnimateShowChangeCellRenderer",
      filter: "agNumberColumnFilter",
    },
    totalColumn: {
      cellRenderer: "agAnimateShowChangeCellRenderer",
      cellClass: "number-cell",
    },
  };
  aggFuncs: IAggFuncs = {
    sum: (params) => {
      const values = params && params.values ? params.values : [];
      let result = 0;
      if (values) {
        values.forEach((value) => {
          if (typeof value === "number") {
            result += value;
          }
        });
      }
      callCount++;
      console.log(
        callCount + " aggregation: sum([" + values.join(",") + "]) = " + result,
      );
      return result;
    },
  };
  groupDefaultExpanded = 1;
  getRowId: GetRowIdFunc = (params: GetRowIdParams) => String(params.data.id);
  rowData!: any[];

  updateOneRecord() {
    const rowNodeToUpdate = pickExistingRowNodeAtRandom(this.gridApi);
    if (!rowNodeToUpdate) return;
    const randomValue = createRandomNumber();
    const randomColumnId = pickRandomColumn();
    console.log(
      "updating " + randomColumnId + " to " + randomValue + " on ",
      rowNodeToUpdate.data,
    );
    rowNodeToUpdate.setDataValue(randomColumnId, randomValue);
  }

  updateUsingTransaction() {
    const itemToUpdate = pickExistingRowItemAtRandom(this.gridApi);
    if (!itemToUpdate) {
      return;
    }
    console.log("updating - before", itemToUpdate);
    itemToUpdate[pickRandomColumn()] = createRandomNumber();
    itemToUpdate[pickRandomColumn()] = createRandomNumber();
    const transaction = {
      update: [itemToUpdate],
    };
    console.log("updating - after", itemToUpdate);
    this.gridApi.applyTransaction(transaction);
  }

  removeUsingTransaction() {
    const itemToRemove = pickExistingRowItemAtRandom(this.gridApi);
    if (!itemToRemove) {
      return;
    }
    const transaction = {
      remove: [itemToRemove],
    };
    console.log("removing", itemToRemove);
    this.gridApi.applyTransaction(transaction);
  }

  addUsingTransaction() {
    const i = Math.floor(window.agRandom() * 2);
    const j = Math.floor(window.agRandom() * 5);
    const k = Math.floor(window.agRandom() * 3);
    const newItem = createRowItem(i, j, k);
    const transaction = {
      add: [newItem],
    };
    console.log("adding", newItem);
    this.gridApi.applyTransaction(transaction);
  }

  changeGroupUsingTransaction() {
    const itemToUpdate = pickExistingRowItemAtRandom(this.gridApi);
    if (!itemToUpdate) {
      return;
    }
    itemToUpdate.topGroup = itemToUpdate.topGroup === "Top" ? "Bottom" : "Top";
    const transaction = {
      update: [itemToUpdate],
    };
    console.log("updating", itemToUpdate);
    this.gridApi.applyTransaction(transaction);
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;

    params.api.setGridOption("rowData", createRowData());
  }
}

let rowIdCounter = 0;
let callCount = 0;
function createRowData() {
  const result = [];
  for (let i = 1; i <= 2; i++) {
    for (let j = 1; j <= 5; j++) {
      for (let k = 1; k <= 3; k++) {
        const rowDataItem = createRowItem(i, j, k);
        result.push(rowDataItem);
      }
    }
  }
  return result;
}
function createRowItem(i: number, j: number, k: number) {
  const rowDataItem = {
    id: rowIdCounter++,
    a: (j * k * 863) % 100,
    b: (j * k * 811) % 100,
    c: (j * k * 743) % 100,
    d: (j * k * 677) % 100,
    topGroup: "Bottom",
    group: "Group B" + j,
  };
  if (i === 1) {
    rowDataItem.topGroup = "Top";
    rowDataItem.group = "Group A" + j;
  }
  return rowDataItem;
}
function pickRandomColumn() {
  const letters = ["a", "b", "c", "d"];
  const randomIndex = Math.floor(window.agRandom() * letters.length);
  return letters[randomIndex];
}
function createRandomNumber() {
  return Math.floor(window.agRandom() * 100);
}
function pickExistingRowItemAtRandom(api: GridApi) {
  const rowNode = pickExistingRowNodeAtRandom(api);
  return rowNode ? rowNode.data : null;
}
function pickExistingRowNodeAtRandom(api: GridApi): IRowNode | undefined {
  const allItems: IRowNode[] = [];
  api.forEachLeafNode(function (rowNode) {
    allItems.push(rowNode);
  });
  if (allItems.length === 0) {
    return undefined;
  }
  const result = allItems[Math.floor(window.agRandom() * allItems.length)];
  return result;
}
```

[Live example: Change Detection with Delta Aggregation](https://www.ag-grid.com/examples/change-detection/change-detection-delta-aggregation/angular)

## Change Detection and Pivot

Everything above stands for when you are doing [pivoting](https://www.ag-grid.com/angular-data-grid/pivoting/). There are no new concepts to introduce, so let's just get stuck into an example.

When you click any of the buttons below, remember you are not changing the displayed cells values, as when you pivot, each cell is an aggregation of underlying data and the underlying data is no longer displayed in the grid (doing a pivot removes leaf nodes).

From the example, you can observe:

- Uncheck '**Group & Pivot**' to see what the data looks like when it is flat. You can see it's a list of student records showing student scores and age. For seeing the impact of value changes on pivots, keep this checked while selecting the other buttons.
- Button '**Set One Value**' updates one value using `rowNode.setDataValue(col,value)`. The grid aggregates the new value for display.
- Button '**Update Points**' updates one record using `api.applyTransaction(transaction)`. The grid aggregates the new value for display.
- Button '**Add Year 5**' adds one record for 'Year 5' using `api.applyTransaction(transaction)`. The grid does a delta change and adds one more row to represent this group while not touching the DOM with the remaining rows.
- Button '**Add Physics Row**' adds one record with subject 'Physics' using `api.applyTransaction(transaction)`. This impacts the columns in the grid as we are pivoting on 'course', so a new column is added for 'Physics'. Again this is all done without touching the remaining columns or rows in the grid.
- Button '**Remove All Physics**' removes all 'Physics' records `api.applyTransaction(transaction)`. As before, this impacts the columns, all 'Physics' columns are removed.
- Button '**Move Course**' updates a row's course using `api.applyTransaction(transaction)`. This results in the aggregations changing in two locations, once where the course was removed, and another where the course was added.

#### Change Detection Pivot

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  IRowNode,
  ModuleRegistry,
  ValueGetterParams,
  enableDevValidations,
} from "ag-grid-community";
import { PivotModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnApiModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  PivotModule,
  HighlightChangesModule,
]);

interface Student {
  student: number;
  yearGroup: string;
  age: number;
  course: string;
  points: number;
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div class="example-header">
      <div>
        <label>
          <input type="checkbox" id="pivot-mode" (click)="pivotMode()" />
          Group &amp; Pivot
        </label>
      </div>

      <div style="margin-top: 6px">
        <button (click)="updateOneRecord()">Set One Value</button>
        <button (click)="updateUsingTransaction()">Update Points</button>
        <button (click)="addNewGroupUsingTransaction()">Add Year 5</button>
        <button (click)="addNewCourse()">Add Physics Row</button>
        <button (click)="removePhysics()">Remove All Physics</button>
        <button (click)="moveCourse()">Move Course</button>
      </div>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [rowData]="rowData"
      [pivotMode]="true"
      [groupDefaultExpanded]="groupDefaultExpanded"
      [getRowId]="getRowId"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  columnDefs: ColDef[] = [
    { headerName: "Student ID", field: "student" },
    { headerName: "Year Group", field: "yearGroup", rowGroup: true },
    { headerName: "Age", field: "age" },
    { headerName: "Course", field: "course", pivot: true },
    {
      headerName: "Age Range",
      valueGetter: ageRangeValueGetter,
      pivot: true,
    },
    { headerName: "Points", field: "points", aggFunc: "sum" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 150,
    cellRenderer: "agAnimateShowChangeCellRenderer",
  };
  rowData: any[] | null = getRowData();
  groupDefaultExpanded = 1;
  getRowId: GetRowIdFunc = (params: GetRowIdParams) =>
    String(params.data.student);

  pivotMode() {
    const pivotModeOn = (
      document.getElementById("pivot-mode") as HTMLInputElement
    ).checked;
    this.gridApi.setGridOption("pivotMode", pivotModeOn);
    this.gridApi.applyColumnState({
      state: [
        { colId: "yearGroup", rowGroup: pivotModeOn },
        { colId: "course", pivot: pivotModeOn, pivotIndex: 1 },
        { colId: "ageRange", pivot: pivotModeOn, pivotIndex: 0 },
      ],
    });
  }

  updateOneRecord() {
    const rowNodeToUpdate = pickExistingRowNodeAtRandom(this.gridApi);
    if (!rowNodeToUpdate) return;
    const randomValue = createNewRandomScore(rowNodeToUpdate.data);
    console.log(
      "updating points to " + randomValue + " on ",
      rowNodeToUpdate.data,
    );
    rowNodeToUpdate.setDataValue("points", randomValue);
  }

  updateUsingTransaction() {
    const itemToUpdate = pickExistingRowItemAtRandom(this.gridApi);
    if (!itemToUpdate) {
      return;
    }
    console.log("updating - before", itemToUpdate);
    itemToUpdate.points = createNewRandomScore(itemToUpdate);
    const transaction = {
      update: [itemToUpdate],
    };
    console.log("updating - after", itemToUpdate);
    this.gridApi.applyTransaction(transaction);
  }

  addNewGroupUsingTransaction() {
    const item1 = createRow();
    const item2 = createRow();
    item1.yearGroup = "Year 5";
    item2.yearGroup = "Year 5";
    const transaction = {
      add: [item1, item2],
    };
    console.log("add - ", item1);
    console.log("add - ", item2);
    this.gridApi.applyTransaction(transaction);
  }

  addNewCourse() {
    const item1 = createRow();
    item1.course = "Physics";
    const transaction = {
      add: [item1],
    };
    console.log("add - ", item1);
    this.gridApi.applyTransaction(transaction);
  }

  removePhysics() {
    const allPhysics: any = [];
    this.gridApi.forEachLeafNode(function (rowNode) {
      if (rowNode.data.course === "Physics") {
        allPhysics.push(rowNode.data);
      }
    });
    const transaction = {
      remove: allPhysics,
    };
    console.log("removing " + allPhysics.length + " physics items.");
    this.gridApi.applyTransaction(transaction);
  }

  moveCourse() {
    const item = pickExistingRowItemAtRandom(this.gridApi);
    if (!item) {
      return;
    }
    item.course = item.course === "History" ? "Science" : "History";
    const transaction = {
      update: [item],
    };
    console.log("moving ", item);
    this.gridApi.applyTransaction(transaction);
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;

    (document.getElementById("pivot-mode") as HTMLInputElement).checked = true;
  }
}

function ageRangeValueGetter(params: ValueGetterParams) {
  const age = params.getValue("age");
  if (age === undefined) {
    return null;
  }
  if (age < 20) {
    return "< 20";
  } else if (age > 30) {
    return "> 30";
  } else {
    return "20 to 30";
  }
}
// pretty basic, but deterministic (so same numbers each time we run), random number generator
var seed: number;
function random() {
  seed = ((seed || 1) * 16807) % 2147483647;
  return seed;
}
function getRowData() {
  const rowData = [];
  for (let i = 1; i <= 100; i++) {
    const row = createRow();
    rowData.push(row);
  }
  return rowData;
}
var studentId: number;
function createRow() {
  studentId = studentId ? studentId : 10023;
  const randomNumber = random();
  return {
    student: studentId++,
    points: (randomNumber % 60) + 40,
    course: ["Science", "History"][randomNumber % 3 === 0 ? 0 : 1],
    yearGroup: "Year " + ((randomNumber % 4) + 1), // 'Year 1' to 'Year 4'
    age: (randomNumber % 25) + 15, // 15 to 40
  };
}
function createNewRandomScore(data: Student) {
  let randomValue = createRandomNumber();
  // make sure random number is not actually the same number again
  while (randomValue === data.points) {
    randomValue = createRandomNumber();
  }
  return randomValue;
}
function createRandomNumber() {
  return Math.floor(window.agRandom() * 100);
}
function pickExistingRowNodeAtRandom(api: GridApi) {
  const allItems: IRowNode[] = [];
  api.forEachLeafNode(function (rowNode) {
    allItems.push(rowNode);
  });
  if (allItems.length === 0) {
    return;
  }
  const result = allItems[Math.floor(window.agRandom() * allItems.length)];
  return result;
}
function pickExistingRowItemAtRandom(api: GridApi): Student | null {
  const rowNode = pickExistingRowNodeAtRandom(api);
  return rowNode ? rowNode.data : null;
}
```

[Live example: Change Detection Pivot](https://www.ag-grid.com/examples/change-detection/change-detection-pivot/angular)


---
title: "Change Detection"
framework: react
version: "36.1.0"
---

# Change Detection

The grid has built in change detection. When a value in the grid changes, either via the UI or via the grid API, the grid will check all cells to see which ones need updating and update only those cells, so minimal changes are made to the DOM.

Change detection can be broken down into the following two categories:

1. **Value Change Detection:** When a value for any cell changes (e.g. after an edit), the grid goes through every cell in the grid and compares the current value to the previous value. If the values differ, the cell is refreshed. This allows all cells using `valueGetters` to be kept up to date where a change to one cell (that was edited) may impact the value of another cell (that references the first cell).
2. **Aggregation Change Detection:** When a value for any cell changes, the grid will recalculate all [aggregations](https://www.ag-grid.com/react-data-grid/aggregation/) that are impacted by the changed value. This means the grid will automatically keep aggregation results (the values in the grouped row) up to date as the data beneath it changes.

> **Note**
>
> If you are using a custom cell renderer see [Cell Components](https://www.ag-grid.com/react-data-grid/component-cell-renderer/) for more details on how to update your component following change detection.

## Example: Change Detection and Value Getters

The example below shows the impact of change detection on value getters. The grid is doing all the refresh by itself with no need for the client application explicitly requesting a refresh. Notice the following:

- The 'Total' column uses a value getter to calculate the sum of all values in that row.
- Edit any of the values in columns A to F by double clicking a cell and entering a new value.
- The 'Total' column gets automatically refreshed and flashes.

#### Change Detection and Value Getters

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GridApi,
  GridOptions,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  TextEditorModule,
  TextFilterModule,
  HighlightChangesModule,
  CellStyleModule,
  ClientSideRowModelModule,
  NumberFilterModule,
  NumberEditorModule,
];

function getRowData() {
  const rowData = [];
  for (let i = 1; i <= 20; i++) {
    rowData.push({
      group: i < 5 ? "A" : "B",
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
      e: (i * 619) % 100,
      f: (i * 571) % 100,
    });
  }
  return rowData;
}

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getRowData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "a", type: "valueColumn" },
    { field: "b", type: "valueColumn" },
    { field: "c", type: "valueColumn" },
    { field: "d", type: "valueColumn" },
    { field: "e", type: "valueColumn" },
    { field: "f", type: "valueColumn" },
    {
      headerName: "Total",
      valueGetter: "data.a + data.b + data.c + data.d + data.e + data.f",
      editable: false,
      cellClass: "total-col",
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      enableCellChangeFlash: true,
    };
  }, []);
  const columnTypes = useMemo<ColTypeDefs>(() => {
    return {
      valueColumn: {
        minWidth: 90,
        editable: true,
        filter: "agNumberColumnFilter",
      },
    };
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            columnTypes={columnTypes}
            groupDefaultExpanded={1}
            suppressAggFuncInHeader={true}
            allowShowChangeAfterFilter={true}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Change Detection and Value Getters](https://www.ag-grid.com/examples/change-detection/change-detection-value-getters/reactFunctionalTs)

## 1. Value Change Detection

The grid keeps a local copy of all values rendered in each cell. When a refresh of the cell is requested, the cell will only be refreshed if the value has changed.

> **Note**
>
> You might ask, is checking every cell against its value a performance problem? The answer is no. What AG Grid does is similar to the change detection algorithms in frameworks. Doing this many checks in JavaScript is not a problem. Slowness comes when the DOM is updated many times. AG Grid minimises the DOM updates by only updating the DOM where changes are detected.

### Comparing Values

This section explains how the grid compares values. This is of interest if you want to compare values in a different way.

By default the grid will compare values by using triple equals, eg `"oldValue === newValue"`. This will work most of the time for you, especially if your values are simple types (string, number, boolean) or immutable objects. This will be a problem for mutable objects as object references will be used for comparison which won't detect internal changes in the object. If using mutable objects (data has changed but it's the same object reference), then you will need to override how the value's are compared.

If your row data attributes are simple types (string, boolean, number) or immutable objects you don't need to implement your own comparison method.

If you do need to provide custom comparison of objects, use the `colDef.equals(val1,val2)` method. For example, the following code snippet provides custom comparison to a 'Name' column where the name is stored in a complex object.

```jsx
const [columnDefs, setColumnDefs] = useState([
    {
        field: 'person',
        // method returns true if first and last names are equal
        equals: (person1, person2) => {
            const firstNameEqual = person1.firstName === person2.firstName;
            const lastNameEqual = person2.lastName === person2.lastName;
            return firstNameEqual && lastNameEqual;
        }
    }
]);

<AgGridReact columnDefs={columnDefs} />
```

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `equals` | `EqualsFunc` |  |  | Custom comparator for values, used by renderer to know if values have changed. Cells whose values have not changed don't get refreshed. By default the grid uses `===` which should work for most use cases. |

### Triggering Value Change Detection

The following operations will **automatically** trigger change detection on all visible cells:

1. Editing any value via the grid UI (e.g. double clicking a cell and entering a new value).
2. Using the `rowNode.setDataValue(col,value)` Row Node method.
3. Using the `api.applyTransaction(transaction)` API method.
4. Group value edited if `refreshAfterGroupEdit` grid option is set to `true`, (see [Grouping Edit](https://www.ag-grid.com/react-data-grid/grouping-edit/)).

If you do not want change detection to be automatically done, then set the grid property `suppressChangeDetection=true`. This will stop the change detection process firing when the above events happen. Ideally you should not want to turn off change detection, however the option is there if you choose to turn it off. One thing that may entice you to turn it off is if you have some custom Value Getters or Cell Class Rules that are doing some time intensive calculations, you may want limit the number of times they are called and have more control over when refreshing is done.

To **manually** run Value Change Detection to refresh all visible cells call [api.refreshCells()](https://www.ag-grid.com/react-data-grid/view-refresh/).

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `refreshCells` | `Function` |  |  | Performs change detection on all cells, refreshing cells where required. Module: [`RenderApiModule`](https://www.ag-grid.com/react-data-grid/modules/). |

## 2. Aggregation Change Detection

Aggregation change detection means rerunning [aggregations](https://www.ag-grid.com/react-data-grid/aggregation/) when a value changes. So for example, if you are grouping by a column and summing by a value, and one of those values change, then the summed value should also change.

> **Note**
>
> If you want edited rows to jump to their new groups automatically, enable [Grouping Edit](https://www.ag-grid.com/react-data-grid/grouping-edit/) by setting the grid property `refreshAfterGroupEdit=true`. This property triggers the necessary regroup, sort and filter refresh after the edit and is our preferred approach when inline editing grouped columns.

### Flashing Cells During Filter Updates

By default, the grid does not flash cells when filtering is applied, even if the value in the aggregated cell has changed. To change this behaviour, set the grid property `allowShowChangeAfterFilter=true`.

This only affects cell flashing (`enableCellChangeFlash`). The [Value Getters example](#example-change-detection-and-value-getters) above sets `allowShowChangeAfterFilter=true`, so that flashing remains visible while filtering. The other examples on this page use [animation cell renderers](https://www.ag-grid.com/react-data-grid/change-cell-renderers/) instead of flashing, so the property has no effect on them.

### Example: Re-Aggregation of Groups

The example below shows change detection impacting the result of groups. The grid is doing all the refresh by itself with no need for the client application explicitly requesting a refresh. Notice the following:

- Column 'Group' is marked as a [Row Group](https://www.ag-grid.com/react-data-grid/grouping/) and columns A to D are marked as [Aggregation](https://www.ag-grid.com/react-data-grid/aggregation/) columns so that their values are summed into the group level.
- Column 'Total' has a valueGetter which gives a sum of all columns A to D.
- Columns A to D are editable. If you edit a cells value, then the aggregate value at the group level is also updated to reflect the change. This is because the grid is recalculating the aggregations as a result of the change.
- All cells are configured to use one of the grids [animation cell renderer](https://www.ag-grid.com/react-data-grid/change-cell-renderers/) instead of flashing cells.

#### Change Detection with Groups

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  AutoGroupColumnDef,
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GridApi,
  GridOptions,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  TextEditorModule,
  TextFilterModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
  HighlightChangesModule,
  NumberFilterModule,
  NumberEditorModule,
];

function getRowData() {
  const rowData = [];
  for (let i = 1; i <= 16; i++) {
    rowData.push({
      group: i < 8 ? "A" : "B",
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
    });
  }
  return rowData;
}

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getRowData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "group", rowGroup: true, editable: true },
    { field: "a", type: "valueColumn" },
    { field: "b", type: "valueColumn" },
    { field: "c", type: "valueColumn" },
    { field: "d", type: "valueColumn" },
    {
      headerName: "Total",
      type: "totalColumn",
      valueGetter:
        'getValue("a") + getValue("b") + getValue("c") + getValue("d")',
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 100,
    };
  }, []);
  const columnTypes = useMemo<ColTypeDefs>(() => {
    return {
      valueColumn: {
        minWidth: 90,
        editable: true,
        aggFunc: "sum",
        cellClass: "number-cell",
        cellRenderer: "agAnimateShowChangeCellRenderer",
        filter: "agNumberColumnFilter",
      },
      totalColumn: {
        cellRenderer: "agAnimateShowChangeCellRenderer",
        cellClass: "number-cell",
      },
    };
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            autoGroupColumnDef={autoGroupColumnDef}
            columnTypes={columnTypes}
            groupDefaultExpanded={1}
            suppressAggFuncInHeader={true}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Change Detection with Groups](https://www.ag-grid.com/examples/change-detection/change-detection-groups/reactFunctionalTs)

Notice above that the group column is also editable (eg you can change one of the rows from group 'A' to group 'G'), however the row does **not** move into the correct group after this change is made. This is discussed below in the section [Change Detection and Sorting, Filtering, Grouping](#change-detection-and-sorting-filtering-grouping).

### Refreshing Groups After Inline Edits

By default the grid keeps the edited row in place until you manually refresh the client-side row model. This prevents jarring row movement while the user is typing, but it can look incorrect if group edits are infrequent and you expect the row to relocate immediately.

`refreshAfterGroupEdit` flips that behaviour. When set to `true`, the grid automatically reruns grouping, sorting and filtering after the edit is committed, so the row will move according to its new value.

```ts
const gridOptions = {
    refreshAfterGroupEdit: true,
    // other grid options
};
```

See [Grouping Edit](https://www.ag-grid.com/react-data-grid/grouping-edit/) for more details.

### Triggering Aggregation Change Detection

The following operations will **automatically** trigger aggregation change detection:

1. Editing any value via the grid UI (e.g. double clicking a cell and entering a new value).
2. Using the `rowNode.setDataValue(col,value)` Row Node method.
3. Using the `api.applyTransaction(transaction)` API method.

To **manually** run aggregation change detection to re-compute the aggregated values, then call [api.refreshClientSideRowModel('aggregate')](https://www.ag-grid.com/react-data-grid/grid-api/#reference-data-refreshClientSideRowModel).

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `refreshClientSideRowModel` | `Function` |  |  | Refresh the Client-Side Row Model, executing the grouping, filtering and sorting again. Optionally provide the step you wish the refresh to apply from. Defaults to `everything`. Module: [`ClientSideRowModelApiModule`](https://www.ag-grid.com/react-data-grid/modules/). |

## Change Detection and Sorting, Filtering, Grouping

When a value changes, the grid's automatic change detection will update:

- Aggregated values.
- Values displayed in cells.

The grid will **not**:

- Sort
- Filter
- Group

The reason why sorting, filtering and grouping is not done automatically is that it would be considered bad user experience in most use cases to change the displayed rows while editing. For example, if a user edits a cell, then the row should not jump location (due to sorting and grouping) or even worse, disappear altogether (if the filter removes the row due to the new value failing the filter).

For this reason, if you want to update the sorting, filtering or group grouping after an update, you should listen for the event `cellValueChanged` and call [api.applyTransaction(transaction)](https://www.ag-grid.com/react-data-grid/data-update-transactions/#transaction-update-api) with the rows that were updated.

### Example: Change Detection and Filter / Sort / Group

The following example is the same as the example above [Change Detection and Groups](#example-change-detection-groups) except it gets the grid to do a transaction update so that the grouping, sorting and filtering are recomputed. From the example, the following can be noted:

- As before, updating any value will update the total column and aggregated group columns.
- Updating a group cell will move the row to the new group. If the group does not exist, it will be created.
- If you order by a column (eg order by 'A') and then change the data so that the order is incorrect, the grid will fix itself so that the ordering is maintained. In other words, the updated row will move to the new sorted position.
- If you set a filter (eg filter 'A' to be 'less than 50') and then change the data so that a row no longer passes the filter, the grid will fix itself so that the filtering is maintained. In other words, the updated row will be removed if it no longer passes the filter.

#### Change Detection with Filter / Sort / Group

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  AutoGroupColumnDef,
  CellStyleModule,
  CellValueChangedEvent,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GridApi,
  GridOptions,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, SetFilterModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  ClientSideRowModelApiModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
  SetFilterModule,
  HighlightChangesModule,
  NumberFilterModule,
  NumberEditorModule,
  TextEditorModule,
];

function getRowData() {
  const rowData = [];
  for (let i = 1; i <= 10; i++) {
    rowData.push({
      group: i < 5 ? "A" : "B",
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
    });
  }
  return rowData;
}

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getRowData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    // do NOT hide this column, it's needed for editing
    { field: "group", rowGroup: true, editable: true },
    { field: "a", type: "valueColumn" },
    { field: "b", type: "valueColumn" },
    { field: "c", type: "valueColumn" },
    { field: "d", type: "valueColumn" },
    {
      headerName: "Total",
      type: "totalColumn",
      valueGetter:
        'getValue("a") + getValue("b") + getValue("c") + getValue("d")',
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      filter: true,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 100,
    };
  }, []);
  const columnTypes = useMemo<ColTypeDefs>(() => {
    return {
      valueColumn: {
        minWidth: 90,
        editable: true,
        aggFunc: "sum",
        cellClass: "number-cell",
        cellRenderer: "agAnimateShowChangeCellRenderer",
        filter: "agNumberColumnFilter",
      },
      totalColumn: {
        cellRenderer: "agAnimateShowChangeCellRenderer",
        cellClass: "number-cell",
      },
    };
  }, []);

  const onCellValueChanged = useCallback((params: CellValueChangedEvent) => {
    const data = params.data;
    if (data) {
      params.api.applyTransaction({ update: [data] });
    }
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            autoGroupColumnDef={autoGroupColumnDef}
            columnTypes={columnTypes}
            groupDefaultExpanded={1}
            suppressAggFuncInHeader={true}
            onCellValueChanged={onCellValueChanged}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Change Detection with Filter / Sort / Group](https://www.ag-grid.com/examples/change-detection/change-detection-filter-sort-group/reactFunctionalTs)

## Aggregation Path Selection

When data in the grid updates and aggregations are active, the grid will not recompute all aggregations again from scratch. Instead it will be selective as to what aggregations need to be re-computed.

## Tree Path Selection

When a value changes, the grid will recompute the immediate group the row is in, and then any parent group, all the way to the root. This is known as 'tree path selection' - only the part of the tree that need to be recalculated are recalculated.

If you are updating many rows at the same time using an [Update Transaction](https://www.ag-grid.com/react-data-grid/data-update-transactions/), the grid will do all updates first, then recompute all aggregations against the combined impacted paths only.

## Column Path Selection

By default, the grid will recalculate aggregations on all columns for the updated tree path, even if only one of the columns values were changed. This is because the grid assumes any column has the potential to impact any other column, should the column be referenced in a valueGetter.

If you are sure that a value change impacts that one column only, then you can set the grid property `aggregateOnlyChangedColumns=true`. This will re-aggregate only the changed column and not all columns after a single cell is updated.

## Example: Tree Path & Column Path Selection

Consider the example below. When you edit a cell value under the groups "Bottom" -> "Group B2" and column "Column C". The grid will only recompute column C aggregations for "Group B2" and "Bottom". It will not recompute any aggregates for any other groups or for any other columns.

The tree path selection (ie not updating anything in the group "Top") is always active in the grid and the column selection (only updating column "Column C") is active because of the grid property `aggregateOnlyChangedColumns=true`.

The path selections ensure only the minimal amount of recalculations are done.

To demonstrate this, the example installs it's own aggregation function for summing. This is identical to the normal summing provided by the grid while also printing out to the console when it gets called. This allows the example to show when the aggregations are done and on what.

So with the example below, open up the console and notice the following:

- When the grid initialises, the aggregation gets complete 48 times (4 columns * 12 groups). That's all paths in the group tree and all columns.
- When one value changes (either via UI or via the first button 'Update One Value') then the grid recomputes the values for the impacted path only, and for the changed column only.
- When some values change via a transactions using any of the other buttons, then all columns are recomputed but only on the changed path.

#### Change Detection with Delta Aggregation

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import {
  AutoGroupColumnDef,
  CellStyleModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  IAggFuncs,
  IRowNode,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  ValueParserParams,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, SetFilterModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  ClientSideRowModelApiModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
  SetFilterModule,
  HighlightChangesModule,
  NumberFilterModule,
  NumberEditorModule,
  TextEditorModule,
];

let rowIdCounter = 0;

let callCount = 0;

function createRowData() {
  const result = [];
  for (let i = 1; i <= 2; i++) {
    for (let j = 1; j <= 5; j++) {
      for (let k = 1; k <= 3; k++) {
        const rowDataItem = createRowItem(i, j, k);
        result.push(rowDataItem);
      }
    }
  }
  return result;
}

function createRowItem(i: number, j: number, k: number) {
  const rowDataItem = {
    id: rowIdCounter++,
    a: (j * k * 863) % 100,
    b: (j * k * 811) % 100,
    c: (j * k * 743) % 100,
    d: (j * k * 677) % 100,
    topGroup: "Bottom",
    group: "Group B" + j,
  };
  if (i === 1) {
    rowDataItem.topGroup = "Top";
    rowDataItem.group = "Group A" + j;
  }
  return rowDataItem;
}

function pickRandomColumn() {
  const letters = ["a", "b", "c", "d"];
  const randomIndex = Math.floor(window.agRandom() * letters.length);
  return letters[randomIndex];
}

function createRandomNumber() {
  return Math.floor(window.agRandom() * 100);
}

function pickExistingRowItemAtRandom(api: GridApi) {
  const rowNode = pickExistingRowNodeAtRandom(api);
  return rowNode ? rowNode.data : null;
}

const pickExistingRowNodeAtRandom: (api: GridApi) => IRowNode | undefined = (
  api: GridApi,
) => {
  const allItems: IRowNode[] = [];
  api.forEachLeafNode(function (rowNode) {
    allItems.push(rowNode);
  });
  if (allItems.length === 0) {
    return undefined;
  }
  const result = allItems[Math.floor(window.agRandom() * allItems.length)];
  return result;
};

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>();
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "topGroup", rowGroup: true, hide: true },
    { field: "group", rowGroup: true, hide: true },
    { headerName: "ID", field: "id", cellClass: "number-cell", maxWidth: 70 },
    { field: "a", type: "valueColumn" },
    { field: "b", type: "valueColumn" },
    { field: "c", type: "valueColumn" },
    { field: "d", type: "valueColumn" },
    {
      headerName: "Total",
      type: "totalColumn",
      minWidth: 120,
      valueGetter:
        'getValue("a") + getValue("b") + getValue("c") + getValue("d")',
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 180,
    };
  }, []);
  const columnTypes = useMemo<ColTypeDefs>(() => {
    return {
      valueColumn: {
        minWidth: 90,
        editable: true,
        aggFunc: "sum",
        cellClass: "number-cell",
        cellRenderer: "agAnimateShowChangeCellRenderer",
        filter: "agNumberColumnFilter",
      },
      totalColumn: {
        cellRenderer: "agAnimateShowChangeCellRenderer",
        cellClass: "number-cell",
      },
    };
  }, []);
  const aggFuncs = useMemo<IAggFuncs>(() => {
    return {
      sum: (params) => {
        const values = params && params.values ? params.values : [];
        let result = 0;
        if (values) {
          values.forEach((value) => {
            if (typeof value === "number") {
              result += value;
            }
          });
        }
        callCount++;
        console.log(
          callCount +
            " aggregation: sum([" +
            values.join(",") +
            "]) = " +
            result,
        );
        return result;
      },
    };
  }, []);
  const getRowId = useCallback(
    (params: GetRowIdParams) => String(params.data.id),
    [],
  );

  const onGridReady = useCallback((params: GridReadyEvent) => {
    setRowData(createRowData());
  }, []);

  const updateOneRecord = useCallback(() => {
    const rowNodeToUpdate = pickExistingRowNodeAtRandom(gridRef.current!.api!);
    if (!rowNodeToUpdate) return;
    const randomValue = createRandomNumber();
    const randomColumnId = pickRandomColumn();
    console.log(
      "updating " + randomColumnId + " to " + randomValue + " on ",
      rowNodeToUpdate.data,
    );
    rowNodeToUpdate.setDataValue(randomColumnId, randomValue);
  }, []);

  const updateUsingTransaction = useCallback(() => {
    const itemToUpdate = pickExistingRowItemAtRandom(gridRef.current!.api!);
    if (!itemToUpdate) {
      return;
    }
    console.log("updating - before", itemToUpdate);
    itemToUpdate[pickRandomColumn()] = createRandomNumber();
    itemToUpdate[pickRandomColumn()] = createRandomNumber();
    const transaction = {
      update: [itemToUpdate],
    };
    console.log("updating - after", itemToUpdate);
    gridRef.current!.api.applyTransaction(transaction);
  }, []);

  const removeUsingTransaction = useCallback(() => {
    const itemToRemove = pickExistingRowItemAtRandom(gridRef.current!.api!);
    if (!itemToRemove) {
      return;
    }
    const transaction = {
      remove: [itemToRemove],
    };
    console.log("removing", itemToRemove);
    gridRef.current!.api.applyTransaction(transaction);
  }, []);

  const addUsingTransaction = useCallback(() => {
    const i = Math.floor(window.agRandom() * 2);
    const j = Math.floor(window.agRandom() * 5);
    const k = Math.floor(window.agRandom() * 3);
    const newItem = createRowItem(i, j, k);
    const transaction = {
      add: [newItem],
    };
    console.log("adding", newItem);
    gridRef.current!.api.applyTransaction(transaction);
  }, []);

  const changeGroupUsingTransaction = useCallback(() => {
    const itemToUpdate = pickExistingRowItemAtRandom(gridRef.current!.api!);
    if (!itemToUpdate) {
      return;
    }
    itemToUpdate.topGroup = itemToUpdate.topGroup === "Top" ? "Bottom" : "Top";
    const transaction = {
      update: [itemToUpdate],
    };
    console.log("updating", itemToUpdate);
    gridRef.current!.api.applyTransaction(transaction);
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="parent-container">
          <div className="top-container">
            <button onClick={updateOneRecord}>Update One Value</button>
            <button onClick={updateUsingTransaction}>
              Update Using Transaction
            </button>
            <button onClick={removeUsingTransaction}>
              Remove Using Transaction
            </button>
            <button onClick={addUsingTransaction}>Add Using Transaction</button>
            <button onClick={changeGroupUsingTransaction}>
              Change Group Using Transaction
            </button>
          </div>
          <div className="center-container">
            <div style={gridStyle}>
              <AgGridReact
                ref={gridRef}
                rowData={rowData}
                columnDefs={columnDefs}
                defaultColDef={defaultColDef}
                autoGroupColumnDef={autoGroupColumnDef}
                columnTypes={columnTypes}
                aggregateOnlyChangedColumns={true}
                aggFuncs={aggFuncs}
                groupDefaultExpanded={1}
                suppressAggFuncInHeader={true}
                getRowId={getRowId}
                onGridReady={onGridReady}
              />
            </div>
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Change Detection with Delta Aggregation](https://www.ag-grid.com/examples/change-detection/change-detection-delta-aggregation/reactFunctionalTs)

## Change Detection and Pivot

Everything above stands for when you are doing [pivoting](https://www.ag-grid.com/react-data-grid/pivoting/). There are no new concepts to introduce, so let's just get stuck into an example.

When you click any of the buttons below, remember you are not changing the displayed cells values, as when you pivot, each cell is an aggregation of underlying data and the underlying data is no longer displayed in the grid (doing a pivot removes leaf nodes).

From the example, you can observe:

- Uncheck '**Group & Pivot**' to see what the data looks like when it is flat. You can see it's a list of student records showing student scores and age. For seeing the impact of value changes on pivots, keep this checked while selecting the other buttons.
- Button '**Set One Value**' updates one value using `rowNode.setDataValue(col,value)`. The grid aggregates the new value for display.
- Button '**Update Points**' updates one record using `api.applyTransaction(transaction)`. The grid aggregates the new value for display.
- Button '**Add Year 5**' adds one record for 'Year 5' using `api.applyTransaction(transaction)`. The grid does a delta change and adds one more row to represent this group while not touching the DOM with the remaining rows.
- Button '**Add Physics Row**' adds one record with subject 'Physics' using `api.applyTransaction(transaction)`. This impacts the columns in the grid as we are pivoting on 'course', so a new column is added for 'Physics'. Again this is all done without touching the remaining columns or rows in the grid.
- Button '**Remove All Physics**' removes all 'Physics' records `api.applyTransaction(transaction)`. As before, this impacts the columns, all 'Physics' columns are removed.
- Button '**Move Course**' updates a row's course using `api.applyTransaction(transaction)`. This results in the aggregations changing in two locations, once where the course was removed, and another where the course was added.

#### Change Detection Pivot

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  IRowNode,
  ModuleRegistry,
  ValueGetterParams,
  enableDevValidations,
} from "ag-grid-community";
import { PivotModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  ColumnApiModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  PivotModule,
  HighlightChangesModule,
];

interface Student {
  student: number;
  yearGroup: string;
  age: number;
  course: string;
  points: number;
}

function ageRangeValueGetter(params: ValueGetterParams) {
  const age = params.getValue("age");
  if (age === undefined) {
    return null;
  }
  if (age < 20) {
    return "< 20";
  } else if (age > 30) {
    return "> 30";
  } else {
    return "20 to 30";
  }
}

// pretty basic, but deterministic (so same numbers each time we run), random number generator
var seed: number;

function random() {
  seed = ((seed || 1) * 16807) % 2147483647;
  return seed;
}

function getRowData() {
  const rowData = [];
  for (let i = 1; i <= 100; i++) {
    const row = createRow();
    rowData.push(row);
  }
  return rowData;
}

var studentId: number;

function createRow() {
  studentId = studentId ? studentId : 10023;
  const randomNumber = random();
  return {
    student: studentId++,
    points: (randomNumber % 60) + 40,
    course: ["Science", "History"][randomNumber % 3 === 0 ? 0 : 1],
    yearGroup: "Year " + ((randomNumber % 4) + 1), // 'Year 1' to 'Year 4'
    age: (randomNumber % 25) + 15, // 15 to 40
  };
}

function createNewRandomScore(data: Student) {
  let randomValue = createRandomNumber();
  // make sure random number is not actually the same number again
  while (randomValue === data.points) {
    randomValue = createRandomNumber();
  }
  return randomValue;
}

function createRandomNumber() {
  return Math.floor(window.agRandom() * 100);
}

function pickExistingRowNodeAtRandom(api: GridApi) {
  const allItems: IRowNode[] = [];
  api.forEachLeafNode(function (rowNode) {
    allItems.push(rowNode);
  });
  if (allItems.length === 0) {
    return;
  }
  const result = allItems[Math.floor(window.agRandom() * allItems.length)];
  return result;
}

const pickExistingRowItemAtRandom: (api: GridApi) => Student | null = (
  api: GridApi,
) => {
  const rowNode = pickExistingRowNodeAtRandom(api);
  return rowNode ? rowNode.data : null;
};

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getRowData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { headerName: "Student ID", field: "student" },
    { headerName: "Year Group", field: "yearGroup", rowGroup: true },
    { headerName: "Age", field: "age" },
    { headerName: "Course", field: "course", pivot: true },
    {
      headerName: "Age Range",
      valueGetter: ageRangeValueGetter,
      pivot: true,
    },
    { headerName: "Points", field: "points", aggFunc: "sum" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 150,
      cellRenderer: "agAnimateShowChangeCellRenderer",
    };
  }, []);
  const getRowId = useCallback(
    (params: GetRowIdParams) => String(params.data.student),
    [],
  );

  const onGridReady = useCallback((params: GridReadyEvent) => {
    (document.getElementById("pivot-mode") as HTMLInputElement).checked = true;
  }, []);

  const pivotMode = useCallback(() => {
    const pivotModeOn = (
      document.getElementById("pivot-mode") as HTMLInputElement
    ).checked;
    gridRef.current!.api.setGridOption("pivotMode", pivotModeOn);
    gridRef.current!.api.applyColumnState({
      state: [
        { colId: "yearGroup", rowGroup: pivotModeOn },
        { colId: "course", pivot: pivotModeOn, pivotIndex: 1 },
        { colId: "ageRange", pivot: pivotModeOn, pivotIndex: 0 },
      ],
    });
  }, []);

  const updateOneRecord = useCallback(() => {
    const rowNodeToUpdate = pickExistingRowNodeAtRandom(gridRef.current!.api!);
    if (!rowNodeToUpdate) return;
    const randomValue = createNewRandomScore(rowNodeToUpdate.data);
    console.log(
      "updating points to " + randomValue + " on ",
      rowNodeToUpdate.data,
    );
    rowNodeToUpdate.setDataValue("points", randomValue);
  }, []);

  const updateUsingTransaction = useCallback(() => {
    const itemToUpdate = pickExistingRowItemAtRandom(gridRef.current!.api!);
    if (!itemToUpdate) {
      return;
    }
    console.log("updating - before", itemToUpdate);
    itemToUpdate.points = createNewRandomScore(itemToUpdate);
    const transaction = {
      update: [itemToUpdate],
    };
    console.log("updating - after", itemToUpdate);
    gridRef.current!.api.applyTransaction(transaction);
  }, []);

  const addNewGroupUsingTransaction = useCallback(() => {
    const item1 = createRow();
    const item2 = createRow();
    item1.yearGroup = "Year 5";
    item2.yearGroup = "Year 5";
    const transaction = {
      add: [item1, item2],
    };
    console.log("add - ", item1);
    console.log("add - ", item2);
    gridRef.current!.api.applyTransaction(transaction);
  }, []);

  const addNewCourse = useCallback(() => {
    const item1 = createRow();
    item1.course = "Physics";
    const transaction = {
      add: [item1],
    };
    console.log("add - ", item1);
    gridRef.current!.api.applyTransaction(transaction);
  }, []);

  const removePhysics = useCallback(() => {
    const allPhysics: any = [];
    gridRef.current!.api.forEachLeafNode(function (rowNode) {
      if (rowNode.data.course === "Physics") {
        allPhysics.push(rowNode.data);
      }
    });
    const transaction = {
      remove: allPhysics,
    };
    console.log("removing " + allPhysics.length + " physics items.");
    gridRef.current!.api.applyTransaction(transaction);
  }, []);

  const moveCourse = useCallback(() => {
    const item = pickExistingRowItemAtRandom(gridRef.current!.api!);
    if (!item) {
      return;
    }
    item.course = item.course === "History" ? "Science" : "History";
    const transaction = {
      update: [item],
    };
    console.log("moving ", item);
    gridRef.current!.api.applyTransaction(transaction);
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div className="example-header">
            <div>
              <label>
                <input type="checkbox" id="pivot-mode" onClick={pivotMode} />
                Group &amp; Pivot
              </label>
            </div>

            <div style={{ marginTop: "6px" }}>
              <button onClick={updateOneRecord}>Set One Value</button>
              <button onClick={updateUsingTransaction}>Update Points</button>
              <button onClick={addNewGroupUsingTransaction}>Add Year 5</button>
              <button onClick={addNewCourse}>Add Physics Row</button>
              <button onClick={removePhysics}>Remove All Physics</button>
              <button onClick={moveCourse}>Move Course</button>
            </div>
          </div>

          <div style={gridStyle}>
            <AgGridReact
              ref={gridRef}
              rowData={rowData}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              pivotMode={true}
              groupDefaultExpanded={1}
              getRowId={getRowId}
              onGridReady={onGridReady}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Change Detection Pivot](https://www.ag-grid.com/examples/change-detection/change-detection-pivot/reactFunctionalTs)


---
title: "Change Detection"
framework: vue
version: "36.1.0"
---

# Change Detection

The grid has built in change detection. When a value in the grid changes, either via the UI or via the grid API, the grid will check all cells to see which ones need updating and update only those cells, so minimal changes are made to the DOM.

Change detection can be broken down into the following two categories:

1. **Value Change Detection:** When a value for any cell changes (e.g. after an edit), the grid goes through every cell in the grid and compares the current value to the previous value. If the values differ, the cell is refreshed. This allows all cells using `valueGetters` to be kept up to date where a change to one cell (that was edited) may impact the value of another cell (that references the first cell).
2. **Aggregation Change Detection:** When a value for any cell changes, the grid will recalculate all [aggregations](https://www.ag-grid.com/vue-data-grid/aggregation/) that are impacted by the changed value. This means the grid will automatically keep aggregation results (the values in the grouped row) up to date as the data beneath it changes.

> **Note**
>
> If you are using a custom cell renderer see [Cell Components](https://www.ag-grid.com/vue-data-grid/component-cell-renderer/) for more details on how to update your component following change detection.

## Example: Change Detection and Value Getters

The example below shows the impact of change detection on value getters. The grid is doing all the refresh by itself with no need for the client application explicitly requesting a refresh. Notice the following:

- The 'Total' column uses a value getter to calculate the sum of all values in that row.
- Edit any of the values in columns A to F by double clicking a cell and entering a new value.
- The 'Total' column gets automatically refreshed and flashes.

#### Change Detection and Value Getters

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextEditorModule,
  TextFilterModule,
  HighlightChangesModule,
  CellStyleModule,
  ClientSideRowModelModule,
  NumberFilterModule,
  NumberEditorModule,
]);

function getRowData() {
  const rowData = [];
  for (let i = 1; i <= 20; i++) {
    rowData.push({
      group: i < 5 ? "A" : "B",
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
      e: (i * 619) % 100,
      f: (i * 571) % 100,
    });
  }
  return rowData;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :columnTypes="columnTypes"
      :rowData="rowData"
      :groupDefaultExpanded="groupDefaultExpanded"
      :suppressAggFuncInHeader="true"
      :allowShowChangeAfterFilter="true"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "a", type: "valueColumn" },
      { field: "b", type: "valueColumn" },
      { field: "c", type: "valueColumn" },
      { field: "d", type: "valueColumn" },
      { field: "e", type: "valueColumn" },
      { field: "f", type: "valueColumn" },
      {
        headerName: "Total",
        valueGetter: "data.a + data.b + data.c + data.d + data.e + data.f",
        editable: false,
        cellClass: "total-col",
      },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      enableCellChangeFlash: true,
    });
    const columnTypes = ref<ColTypeDefs>({
      valueColumn: {
        minWidth: 90,
        editable: true,
        filter: "agNumberColumnFilter",
      },
    });
    const rowData = ref<any[] | null>(getRowData());
    const groupDefaultExpanded = ref(1);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      columnTypes,
      rowData,
      groupDefaultExpanded,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Change Detection and Value Getters](https://www.ag-grid.com/examples/change-detection/change-detection-value-getters/vue3)

## 1. Value Change Detection

The grid keeps a local copy of all values rendered in each cell. When a refresh of the cell is requested, the cell will only be refreshed if the value has changed.

> **Note**
>
> You might ask, is checking every cell against its value a performance problem? The answer is no. What AG Grid does is similar to the change detection algorithms in frameworks. Doing this many checks in JavaScript is not a problem. Slowness comes when the DOM is updated many times. AG Grid minimises the DOM updates by only updating the DOM where changes are detected.

### Comparing Values

This section explains how the grid compares values. This is of interest if you want to compare values in a different way.

By default the grid will compare values by using triple equals, eg `"oldValue === newValue"`. This will work most of the time for you, especially if your values are simple types (string, number, boolean) or immutable objects. This will be a problem for mutable objects as object references will be used for comparison which won't detect internal changes in the object. If using mutable objects (data has changed but it's the same object reference), then you will need to override how the value's are compared.

If your row data attributes are simple types (string, boolean, number) or immutable objects you don't need to implement your own comparison method.

If you do need to provide custom comparison of objects, use the `colDef.equals(val1,val2)` method. For example, the following code snippet provides custom comparison to a 'Name' column where the name is stored in a complex object.

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        field: 'person',
        // method returns true if first and last names are equal
        equals: (person1, person2) => {
            const firstNameEqual = person1.firstName === person2.firstName;
            const lastNameEqual = person2.lastName === person2.lastName;
            return firstNameEqual && lastNameEqual;
        }
    }
];
```

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `equals` | `EqualsFunc` |  |  | Custom comparator for values, used by renderer to know if values have changed. Cells whose values have not changed don't get refreshed. By default the grid uses `===` which should work for most use cases. |

### Triggering Value Change Detection

The following operations will **automatically** trigger change detection on all visible cells:

1. Editing any value via the grid UI (e.g. double clicking a cell and entering a new value).
2. Using the `rowNode.setDataValue(col,value)` Row Node method.
3. Using the `api.applyTransaction(transaction)` API method.
4. Group value edited if `refreshAfterGroupEdit` grid option is set to `true`, (see [Grouping Edit](https://www.ag-grid.com/vue-data-grid/grouping-edit/)).

If you do not want change detection to be automatically done, then set the grid property `suppressChangeDetection=true`. This will stop the change detection process firing when the above events happen. Ideally you should not want to turn off change detection, however the option is there if you choose to turn it off. One thing that may entice you to turn it off is if you have some custom Value Getters or Cell Class Rules that are doing some time intensive calculations, you may want limit the number of times they are called and have more control over when refreshing is done.

To **manually** run Value Change Detection to refresh all visible cells call [api.refreshCells()](https://www.ag-grid.com/vue-data-grid/view-refresh/).

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `refreshCells` | `Function` |  |  | Performs change detection on all cells, refreshing cells where required. Module: [`RenderApiModule`](https://www.ag-grid.com/vue-data-grid/modules/). |

## 2. Aggregation Change Detection

Aggregation change detection means rerunning [aggregations](https://www.ag-grid.com/vue-data-grid/aggregation/) when a value changes. So for example, if you are grouping by a column and summing by a value, and one of those values change, then the summed value should also change.

> **Note**
>
> If you want edited rows to jump to their new groups automatically, enable [Grouping Edit](https://www.ag-grid.com/vue-data-grid/grouping-edit/) by setting the grid property `refreshAfterGroupEdit=true`. This property triggers the necessary regroup, sort and filter refresh after the edit and is our preferred approach when inline editing grouped columns.

### Flashing Cells During Filter Updates

By default, the grid does not flash cells when filtering is applied, even if the value in the aggregated cell has changed. To change this behaviour, set the grid property `allowShowChangeAfterFilter=true`.

This only affects cell flashing (`enableCellChangeFlash`). The [Value Getters example](#example-change-detection-and-value-getters) above sets `allowShowChangeAfterFilter=true`, so that flashing remains visible while filtering. The other examples on this page use [animation cell renderers](https://www.ag-grid.com/vue-data-grid/change-cell-renderers/) instead of flashing, so the property has no effect on them.

### Example: Re-Aggregation of Groups

The example below shows change detection impacting the result of groups. The grid is doing all the refresh by itself with no need for the client application explicitly requesting a refresh. Notice the following:

- Column 'Group' is marked as a [Row Group](https://www.ag-grid.com/vue-data-grid/grouping/) and columns A to D are marked as [Aggregation](https://www.ag-grid.com/vue-data-grid/aggregation/) columns so that their values are summed into the group level.
- Column 'Total' has a valueGetter which gives a sum of all columns A to D.
- Columns A to D are editable. If you edit a cells value, then the aggregate value at the group level is also updated to reflect the change. This is because the grid is recalculating the aggregations as a result of the change.
- All cells are configured to use one of the grids [animation cell renderer](https://www.ag-grid.com/vue-data-grid/change-cell-renderers/) instead of flashing cells.

#### Change Detection with Groups

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  AutoGroupColumnDef,
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextEditorModule,
  TextFilterModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
  HighlightChangesModule,
  NumberFilterModule,
  NumberEditorModule,
]);

function getRowData() {
  const rowData = [];
  for (let i = 1; i <= 16; i++) {
    rowData.push({
      group: i < 8 ? "A" : "B",
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
    });
  }
  return rowData;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :autoGroupColumnDef="autoGroupColumnDef"
      :columnTypes="columnTypes"
      :rowData="rowData"
      :groupDefaultExpanded="groupDefaultExpanded"
      :suppressAggFuncInHeader="true"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "group", rowGroup: true, editable: true },
      { field: "a", type: "valueColumn" },
      { field: "b", type: "valueColumn" },
      { field: "c", type: "valueColumn" },
      { field: "d", type: "valueColumn" },
      {
        headerName: "Total",
        type: "totalColumn",
        valueGetter:
          'getValue("a") + getValue("b") + getValue("c") + getValue("d")',
      },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 100,
    });
    const columnTypes = ref<ColTypeDefs>({
      valueColumn: {
        minWidth: 90,
        editable: true,
        aggFunc: "sum",
        cellClass: "number-cell",
        cellRenderer: "agAnimateShowChangeCellRenderer",
        filter: "agNumberColumnFilter",
      },
      totalColumn: {
        cellRenderer: "agAnimateShowChangeCellRenderer",
        cellClass: "number-cell",
      },
    });
    const rowData = ref<any[] | null>(getRowData());
    const groupDefaultExpanded = ref(1);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      columnTypes,
      rowData,
      groupDefaultExpanded,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Change Detection with Groups](https://www.ag-grid.com/examples/change-detection/change-detection-groups/vue3)

Notice above that the group column is also editable (eg you can change one of the rows from group 'A' to group 'G'), however the row does **not** move into the correct group after this change is made. This is discussed below in the section [Change Detection and Sorting, Filtering, Grouping](#change-detection-and-sorting-filtering-grouping).

### Refreshing Groups After Inline Edits

By default the grid keeps the edited row in place until you manually refresh the client-side row model. This prevents jarring row movement while the user is typing, but it can look incorrect if group edits are infrequent and you expect the row to relocate immediately.

`refreshAfterGroupEdit` flips that behaviour. When set to `true`, the grid automatically reruns grouping, sorting and filtering after the edit is committed, so the row will move according to its new value.

```ts
const gridOptions = {
    refreshAfterGroupEdit: true,
    // other grid options
};
```

See [Grouping Edit](https://www.ag-grid.com/vue-data-grid/grouping-edit/) for more details.

### Triggering Aggregation Change Detection

The following operations will **automatically** trigger aggregation change detection:

1. Editing any value via the grid UI (e.g. double clicking a cell and entering a new value).
2. Using the `rowNode.setDataValue(col,value)` Row Node method.
3. Using the `api.applyTransaction(transaction)` API method.

To **manually** run aggregation change detection to re-compute the aggregated values, then call [api.refreshClientSideRowModel('aggregate')](https://www.ag-grid.com/vue-data-grid/grid-api/#reference-data-refreshClientSideRowModel).

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `refreshClientSideRowModel` | `Function` |  |  | Refresh the Client-Side Row Model, executing the grouping, filtering and sorting again. Optionally provide the step you wish the refresh to apply from. Defaults to `everything`. Module: [`ClientSideRowModelApiModule`](https://www.ag-grid.com/vue-data-grid/modules/). |

## Change Detection and Sorting, Filtering, Grouping

When a value changes, the grid's automatic change detection will update:

- Aggregated values.
- Values displayed in cells.

The grid will **not**:

- Sort
- Filter
- Group

The reason why sorting, filtering and grouping is not done automatically is that it would be considered bad user experience in most use cases to change the displayed rows while editing. For example, if a user edits a cell, then the row should not jump location (due to sorting and grouping) or even worse, disappear altogether (if the filter removes the row due to the new value failing the filter).

For this reason, if you want to update the sorting, filtering or group grouping after an update, you should listen for the event `cellValueChanged` and call [api.applyTransaction(transaction)](https://www.ag-grid.com/vue-data-grid/data-update-transactions/#transaction-update-api) with the rows that were updated.

### Example: Change Detection and Filter / Sort / Group

The following example is the same as the example above [Change Detection and Groups](#example-change-detection-groups) except it gets the grid to do a transaction update so that the grouping, sorting and filtering are recomputed. From the example, the following can be noted:

- As before, updating any value will update the total column and aggregated group columns.
- Updating a group cell will move the row to the new group. If the group does not exist, it will be created.
- If you order by a column (eg order by 'A') and then change the data so that the order is incorrect, the grid will fix itself so that the ordering is maintained. In other words, the updated row will move to the new sorted position.
- If you set a filter (eg filter 'A' to be 'less than 50') and then change the data so that a row no longer passes the filter, the grid will fix itself so that the filtering is maintained. In other words, the updated row will be removed if it no longer passes the filter.

#### Change Detection with Filter / Sort / Group

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  AutoGroupColumnDef,
  CellStyleModule,
  CellValueChangedEvent,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, SetFilterModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelApiModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
  SetFilterModule,
  HighlightChangesModule,
  NumberFilterModule,
  NumberEditorModule,
  TextEditorModule,
]);

function getRowData() {
  const rowData = [];
  for (let i = 1; i <= 10; i++) {
    rowData.push({
      group: i < 5 ? "A" : "B",
      a: (i * 863) % 100,
      b: (i * 811) % 100,
      c: (i * 743) % 100,
      d: (i * 677) % 100,
    });
  }
  return rowData;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :autoGroupColumnDef="autoGroupColumnDef"
      :columnTypes="columnTypes"
      :rowData="rowData"
      :groupDefaultExpanded="groupDefaultExpanded"
      :suppressAggFuncInHeader="true"
      @cell-value-changed="onCellValueChanged"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      // do NOT hide this column, it's needed for editing
      { field: "group", rowGroup: true, editable: true },
      { field: "a", type: "valueColumn" },
      { field: "b", type: "valueColumn" },
      { field: "c", type: "valueColumn" },
      { field: "d", type: "valueColumn" },
      {
        headerName: "Total",
        type: "totalColumn",
        valueGetter:
          'getValue("a") + getValue("b") + getValue("c") + getValue("d")',
      },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      filter: true,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 100,
    });
    const columnTypes = ref<ColTypeDefs>({
      valueColumn: {
        minWidth: 90,
        editable: true,
        aggFunc: "sum",
        cellClass: "number-cell",
        cellRenderer: "agAnimateShowChangeCellRenderer",
        filter: "agNumberColumnFilter",
      },
      totalColumn: {
        cellRenderer: "agAnimateShowChangeCellRenderer",
        cellClass: "number-cell",
      },
    });
    const rowData = ref<any[] | null>(getRowData());
    const groupDefaultExpanded = ref(1);

    function onCellValueChanged(params: CellValueChangedEvent) {
      const data = params.data;
      if (data) {
        params.api.applyTransaction({ update: [data] });
      }
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      columnTypes,
      rowData,
      groupDefaultExpanded,
      onGridReady,
      onCellValueChanged,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Change Detection with Filter / Sort / Group](https://www.ag-grid.com/examples/change-detection/change-detection-filter-sort-group/vue3)

## Aggregation Path Selection

When data in the grid updates and aggregations are active, the grid will not recompute all aggregations again from scratch. Instead it will be selective as to what aggregations need to be re-computed.

## Tree Path Selection

When a value changes, the grid will recompute the immediate group the row is in, and then any parent group, all the way to the root. This is known as 'tree path selection' - only the part of the tree that need to be recalculated are recalculated.

If you are updating many rows at the same time using an [Update Transaction](https://www.ag-grid.com/vue-data-grid/data-update-transactions/), the grid will do all updates first, then recompute all aggregations against the combined impacted paths only.

## Column Path Selection

By default, the grid will recalculate aggregations on all columns for the updated tree path, even if only one of the columns values were changed. This is because the grid assumes any column has the potential to impact any other column, should the column be referenced in a valueGetter.

If you are sure that a value change impacts that one column only, then you can set the grid property `aggregateOnlyChangedColumns=true`. This will re-aggregate only the changed column and not all columns after a single cell is updated.

## Example: Tree Path & Column Path Selection

Consider the example below. When you edit a cell value under the groups "Bottom" -> "Group B2" and column "Column C". The grid will only recompute column C aggregations for "Group B2" and "Bottom". It will not recompute any aggregates for any other groups or for any other columns.

The tree path selection (ie not updating anything in the group "Top") is always active in the grid and the column selection (only updating column "Column C") is active because of the grid property `aggregateOnlyChangedColumns=true`.

The path selections ensure only the minimal amount of recalculations are done.

To demonstrate this, the example installs it's own aggregation function for summing. This is identical to the normal summing provided by the grid while also printing out to the console when it gets called. This allows the example to show when the aggregations are done and on what.

So with the example below, open up the console and notice the following:

- When the grid initialises, the aggregation gets complete 48 times (4 columns * 12 groups). That's all paths in the group tree and all columns.
- When one value changes (either via UI or via the first button 'Update One Value') then the grid recomputes the values for the impacted path only, and for the changed column only.
- When some values change via a transactions using any of the other buttons, then all columns are recomputed but only on the changed path.

#### Change Detection with Delta Aggregation

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
  AutoGroupColumnDef,
  CellStyleModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  IAggFuncs,
  IRowNode,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  ValueParserParams,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, SetFilterModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelApiModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
  SetFilterModule,
  HighlightChangesModule,
  NumberFilterModule,
  NumberEditorModule,
  TextEditorModule,
]);

let rowIdCounter = 0;

let callCount = 0;

function createRowData() {
  const result = [];
  for (let i = 1; i <= 2; i++) {
    for (let j = 1; j <= 5; j++) {
      for (let k = 1; k <= 3; k++) {
        const rowDataItem = createRowItem(i, j, k);
        result.push(rowDataItem);
      }
    }
  }
  return result;
}

function createRowItem(i: number, j: number, k: number) {
  const rowDataItem = {
    id: rowIdCounter++,
    a: (j * k * 863) % 100,
    b: (j * k * 811) % 100,
    c: (j * k * 743) % 100,
    d: (j * k * 677) % 100,
    topGroup: "Bottom",
    group: "Group B" + j,
  };
  if (i === 1) {
    rowDataItem.topGroup = "Top";
    rowDataItem.group = "Group A" + j;
  }
  return rowDataItem;
}

function pickRandomColumn() {
  const letters = ["a", "b", "c", "d"];
  const randomIndex = Math.floor(window.agRandom() * letters.length);
  return letters[randomIndex];
}

function createRandomNumber() {
  return Math.floor(window.agRandom() * 100);
}

function pickExistingRowItemAtRandom(api: GridApi) {
  const rowNode = pickExistingRowNodeAtRandom(api);
  return rowNode ? rowNode.data : null;
}

function pickExistingRowNodeAtRandom(api: GridApi): IRowNode | undefined {
  const allItems: IRowNode[] = [];
  api.forEachLeafNode(function (rowNode) {
    allItems.push(rowNode);
  });
  if (allItems.length === 0) {
    return undefined;
  }
  const result = allItems[Math.floor(window.agRandom() * allItems.length)];
  return result;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="parent-container">
      <div class="top-container">
        <button v-on:click="updateOneRecord()">Update One Value</button>
        <button v-on:click="updateUsingTransaction()">Update Using Transaction</button>
        <button v-on:click="removeUsingTransaction()">Remove Using Transaction</button>
        <button v-on:click="addUsingTransaction()">Add Using Transaction</button>
        <button v-on:click="changeGroupUsingTransaction()">Change Group Using Transaction</button>
      </div>
      <div class="center-container">
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :columnDefs="columnDefs"
          :defaultColDef="defaultColDef"
          :autoGroupColumnDef="autoGroupColumnDef"
          :columnTypes="columnTypes"
          :aggregateOnlyChangedColumns="true"
          :aggFuncs="aggFuncs"
          :groupDefaultExpanded="groupDefaultExpanded"
          :suppressAggFuncInHeader="true"
          :getRowId="getRowId"
          :rowData="rowData"></ag-grid-vue>
        </div>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "topGroup", rowGroup: true, hide: true },
      { field: "group", rowGroup: true, hide: true },
      { headerName: "ID", field: "id", cellClass: "number-cell", maxWidth: 70 },
      { field: "a", type: "valueColumn" },
      { field: "b", type: "valueColumn" },
      { field: "c", type: "valueColumn" },
      { field: "d", type: "valueColumn" },
      {
        headerName: "Total",
        type: "totalColumn",
        minWidth: 120,
        valueGetter:
          'getValue("a") + getValue("b") + getValue("c") + getValue("d")',
      },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 180,
    });
    const columnTypes = ref<ColTypeDefs>({
      valueColumn: {
        minWidth: 90,
        editable: true,
        aggFunc: "sum",
        cellClass: "number-cell",
        cellRenderer: "agAnimateShowChangeCellRenderer",
        filter: "agNumberColumnFilter",
      },
      totalColumn: {
        cellRenderer: "agAnimateShowChangeCellRenderer",
        cellClass: "number-cell",
      },
    });
    const aggFuncs = ref<IAggFuncs>({
      sum: (params) => {
        const values = params && params.values ? params.values : [];
        let result = 0;
        if (values) {
          values.forEach((value) => {
            if (typeof value === "number") {
              result += value;
            }
          });
        }
        callCount++;
        console.log(
          callCount +
            " aggregation: sum([" +
            values.join(",") +
            "]) = " +
            result,
        );
        return result;
      },
    });
    const groupDefaultExpanded = ref(1);
    const getRowId = ref<GetRowIdFunc>((params: GetRowIdParams) =>
      String(params.data.id),
    );
    const rowData = ref<any[]>(null);

    function updateOneRecord() {
      const rowNodeToUpdate = pickExistingRowNodeAtRandom(gridApi.value!);
      if (!rowNodeToUpdate) return;
      const randomValue = createRandomNumber();
      const randomColumnId = pickRandomColumn();
      console.log(
        "updating " + randomColumnId + " to " + randomValue + " on ",
        rowNodeToUpdate.data,
      );
      rowNodeToUpdate.setDataValue(randomColumnId, randomValue);
    }
    function updateUsingTransaction() {
      const itemToUpdate = pickExistingRowItemAtRandom(gridApi.value!);
      if (!itemToUpdate) {
        return;
      }
      console.log("updating - before", itemToUpdate);
      itemToUpdate[pickRandomColumn()] = createRandomNumber();
      itemToUpdate[pickRandomColumn()] = createRandomNumber();
      const transaction = {
        update: [itemToUpdate],
      };
      console.log("updating - after", itemToUpdate);
      gridApi.value!.applyTransaction(transaction);
    }
    function removeUsingTransaction() {
      const itemToRemove = pickExistingRowItemAtRandom(gridApi.value!);
      if (!itemToRemove) {
        return;
      }
      const transaction = {
        remove: [itemToRemove],
      };
      console.log("removing", itemToRemove);
      gridApi.value!.applyTransaction(transaction);
    }
    function addUsingTransaction() {
      const i = Math.floor(window.agRandom() * 2);
      const j = Math.floor(window.agRandom() * 5);
      const k = Math.floor(window.agRandom() * 3);
      const newItem = createRowItem(i, j, k);
      const transaction = {
        add: [newItem],
      };
      console.log("adding", newItem);
      gridApi.value!.applyTransaction(transaction);
    }
    function changeGroupUsingTransaction() {
      const itemToUpdate = pickExistingRowItemAtRandom(gridApi.value!);
      if (!itemToUpdate) {
        return;
      }
      itemToUpdate.topGroup =
        itemToUpdate.topGroup === "Top" ? "Bottom" : "Top";
      const transaction = {
        update: [itemToUpdate],
      };
      console.log("updating", itemToUpdate);
      gridApi.value!.applyTransaction(transaction);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      params.api.setGridOption("rowData", createRowData());
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      columnTypes,
      aggFuncs,
      groupDefaultExpanded,
      getRowId,
      rowData,
      onGridReady,
      updateOneRecord,
      updateUsingTransaction,
      removeUsingTransaction,
      addUsingTransaction,
      changeGroupUsingTransaction,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Change Detection with Delta Aggregation](https://www.ag-grid.com/examples/change-detection/change-detection-delta-aggregation/vue3)

## Change Detection and Pivot

Everything above stands for when you are doing [pivoting](https://www.ag-grid.com/vue-data-grid/pivoting/). There are no new concepts to introduce, so let's just get stuck into an example.

When you click any of the buttons below, remember you are not changing the displayed cells values, as when you pivot, each cell is an aggregation of underlying data and the underlying data is no longer displayed in the grid (doing a pivot removes leaf nodes).

From the example, you can observe:

- Uncheck '**Group & Pivot**' to see what the data looks like when it is flat. You can see it's a list of student records showing student scores and age. For seeing the impact of value changes on pivots, keep this checked while selecting the other buttons.
- Button '**Set One Value**' updates one value using `rowNode.setDataValue(col,value)`. The grid aggregates the new value for display.
- Button '**Update Points**' updates one record using `api.applyTransaction(transaction)`. The grid aggregates the new value for display.
- Button '**Add Year 5**' adds one record for 'Year 5' using `api.applyTransaction(transaction)`. The grid does a delta change and adds one more row to represent this group while not touching the DOM with the remaining rows.
- Button '**Add Physics Row**' adds one record with subject 'Physics' using `api.applyTransaction(transaction)`. This impacts the columns in the grid as we are pivoting on 'course', so a new column is added for 'Physics'. Again this is all done without touching the remaining columns or rows in the grid.
- Button '**Remove All Physics**' removes all 'Physics' records `api.applyTransaction(transaction)`. As before, this impacts the columns, all 'Physics' columns are removed.
- Button '**Move Course**' updates a row's course using `api.applyTransaction(transaction)`. This results in the aggregations changing in two locations, once where the course was removed, and another where the course was added.

#### Change Detection Pivot

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  IRowNode,
  ModuleRegistry,
  ValueGetterParams,
  enableDevValidations,
} from "ag-grid-community";
import { PivotModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnApiModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  PivotModule,
  HighlightChangesModule,
]);

interface Student {
  student: number;
  yearGroup: string;
  age: number;
  course: string;
  points: number;
}

function ageRangeValueGetter(params: ValueGetterParams) {
  const age = params.getValue("age");
  if (age === undefined) {
    return null;
  }
  if (age < 20) {
    return "< 20";
  } else if (age > 30) {
    return "> 30";
  } else {
    return "20 to 30";
  }
}

// pretty basic, but deterministic (so same numbers each time we run), random number generator
var seed: number;

function random() {
  seed = ((seed || 1) * 16807) % 2147483647;
  return seed;
}

function getRowData() {
  const rowData = [];
  for (let i = 1; i <= 100; i++) {
    const row = createRow();
    rowData.push(row);
  }
  return rowData;
}

var studentId: number;

function createRow() {
  studentId = studentId ? studentId : 10023;
  const randomNumber = random();
  return {
    student: studentId++,
    points: (randomNumber % 60) + 40,
    course: ["Science", "History"][randomNumber % 3 === 0 ? 0 : 1],
    yearGroup: "Year " + ((randomNumber % 4) + 1), // 'Year 1' to 'Year 4'
    age: (randomNumber % 25) + 15, // 15 to 40
  };
}

function createNewRandomScore(data: Student) {
  let randomValue = createRandomNumber();
  // make sure random number is not actually the same number again
  while (randomValue === data.points) {
    randomValue = createRandomNumber();
  }
  return randomValue;
}

function createRandomNumber() {
  return Math.floor(window.agRandom() * 100);
}

function pickExistingRowNodeAtRandom(api: GridApi) {
  const allItems: IRowNode[] = [];
  api.forEachLeafNode(function (rowNode) {
    allItems.push(rowNode);
  });
  if (allItems.length === 0) {
    return;
  }
  const result = allItems[Math.floor(window.agRandom() * allItems.length)];
  return result;
}

function pickExistingRowItemAtRandom(api: GridApi): Student | null {
  const rowNode = pickExistingRowNodeAtRandom(api);
  return rowNode ? rowNode.data : null;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div class="example-header">
        <div>
          <label>
            <input type="checkbox" id="pivot-mode" v-on:click="pivotMode()">
              Group &amp; Pivot
            </label>
          </div>
          <div style="margin-top: 6px">
            <button v-on:click="updateOneRecord()">Set One Value</button>
            <button v-on:click="updateUsingTransaction()">Update Points</button>
            <button v-on:click="addNewGroupUsingTransaction()">Add Year 5</button>
            <button v-on:click="addNewCourse()">Add Physics Row</button>
            <button v-on:click="removePhysics()">Remove All Physics</button>
            <button v-on:click="moveCourse()">Move Course</button>
          </div>
        </div>
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :columnDefs="columnDefs"
          :defaultColDef="defaultColDef"
          :rowData="rowData"
          :pivotMode="true"
          :groupDefaultExpanded="groupDefaultExpanded"
          :getRowId="getRowId"></ag-grid-vue>
        </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      { headerName: "Student ID", field: "student" },
      { headerName: "Year Group", field: "yearGroup", rowGroup: true },
      { headerName: "Age", field: "age" },
      { headerName: "Course", field: "course", pivot: true },
      {
        headerName: "Age Range",
        valueGetter: ageRangeValueGetter,
        pivot: true,
      },
      { headerName: "Points", field: "points", aggFunc: "sum" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 150,
      cellRenderer: "agAnimateShowChangeCellRenderer",
    });
    const rowData = ref<any[] | null>(getRowData());
    const groupDefaultExpanded = ref(1);
    const getRowId = ref<GetRowIdFunc>((params: GetRowIdParams) =>
      String(params.data.student),
    );

    function pivotMode() {
      const pivotModeOn = (
        document.getElementById("pivot-mode") as HTMLInputElement
      ).checked;
      gridApi.value!.setGridOption("pivotMode", pivotModeOn);
      gridApi.value!.applyColumnState({
        state: [
          { colId: "yearGroup", rowGroup: pivotModeOn },
          { colId: "course", pivot: pivotModeOn, pivotIndex: 1 },
          { colId: "ageRange", pivot: pivotModeOn, pivotIndex: 0 },
        ],
      });
    }
    function updateOneRecord() {
      const rowNodeToUpdate = pickExistingRowNodeAtRandom(gridApi.value!);
      if (!rowNodeToUpdate) return;
      const randomValue = createNewRandomScore(rowNodeToUpdate.data);
      console.log(
        "updating points to " + randomValue + " on ",
        rowNodeToUpdate.data,
      );
      rowNodeToUpdate.setDataValue("points", randomValue);
    }
    function updateUsingTransaction() {
      const itemToUpdate = pickExistingRowItemAtRandom(gridApi.value!);
      if (!itemToUpdate) {
        return;
      }
      console.log("updating - before", itemToUpdate);
      itemToUpdate.points = createNewRandomScore(itemToUpdate);
      const transaction = {
        update: [itemToUpdate],
      };
      console.log("updating - after", itemToUpdate);
      gridApi.value!.applyTransaction(transaction);
    }
    function addNewGroupUsingTransaction() {
      const item1 = createRow();
      const item2 = createRow();
      item1.yearGroup = "Year 5";
      item2.yearGroup = "Year 5";
      const transaction = {
        add: [item1, item2],
      };
      console.log("add - ", item1);
      console.log("add - ", item2);
      gridApi.value!.applyTransaction(transaction);
    }
    function addNewCourse() {
      const item1 = createRow();
      item1.course = "Physics";
      const transaction = {
        add: [item1],
      };
      console.log("add - ", item1);
      gridApi.value!.applyTransaction(transaction);
    }
    function removePhysics() {
      const allPhysics: any = [];
      gridApi.value!.forEachLeafNode(function (rowNode) {
        if (rowNode.data.course === "Physics") {
          allPhysics.push(rowNode.data);
        }
      });
      const transaction = {
        remove: allPhysics,
      };
      console.log("removing " + allPhysics.length + " physics items.");
      gridApi.value!.applyTransaction(transaction);
    }
    function moveCourse() {
      const item = pickExistingRowItemAtRandom(gridApi.value!);
      if (!item) {
        return;
      }
      item.course = item.course === "History" ? "Science" : "History";
      const transaction = {
        update: [item],
      };
      console.log("moving ", item);
      gridApi.value!.applyTransaction(transaction);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      (document.getElementById("pivot-mode") as HTMLInputElement).checked =
        true;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      groupDefaultExpanded,
      getRowId,
      onGridReady,
      pivotMode,
      updateOneRecord,
      updateUsingTransaction,
      addNewGroupUsingTransaction,
      addNewCourse,
      removePhysics,
      moveCourse,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Change Detection Pivot](https://www.ag-grid.com/examples/change-detection/change-detection-pivot/vue3)
